# EDOMI-Hauptpfad (absolut)
MAIN_PATH="/usr/local/edomi"

# mySQL-DB-Pfad (absolut)
MYSQL_PATH="/var/lib/mysql"

echo -e "\033[42m\033[30m--------------------------------------------------------------------------------\033[49m\033[39m"
echo -e "\033[42m\033[30m                       EDOMI - (c) Dr. Christian Gärtner                        \033[49m\033[39m"
echo -e "\033[42m\033[30m--------------------------------------------------------------------------------\033[49m\033[39m"

# PC-Speaker aktivieren
# modprobe pcspkr
 
# Bildschirmschoner und Monitor-Abschaltung deaktivieren
setterm -blank 0
setterm -powersave off
setterm -powerdown 0
 
# Screenshot: Zugriffsrechte setzen
# chmod 777 /dev/vcs1
chmod 777 /dev/vcsa

# TMP leeren
rm -f /tmp/*.edomi*

# mySQL aufraeumen (manchmal haengt es...)
service mysqld stop
rm -f $MYSQL_PATH/mysql.sock
service mysqld start

# NTP-Abfrage einmalig forcieren
service ntpd stop
timeout 30s ntpd -q -g -x -n
service ntpd start


echo -e "\033[43m\033[30m           >>> EDOMI startet in 3 Sekunden (Abbrechen mit ENTER) <<<            \033[49m\033[39m"
read -t 3
userkey=$?
if (( $userkey == 0 )); then
	echo "EDOMI-Start wurde abgebrochen"
	exit
fi

# Konfiguration parsen
echo "EDOMI-Konfiguration"
php $MAIN_PATH/main/setconfig.php $MAIN_PATH/edomi.ini $MAIN_PATH/www/shared/php/config.php

# rc=0:  Nach einem Reboot wird EDOMI ohne Warten durchgestartet
# rc=10: Nach einem Reboot wird EDOMI gestartet und wartet auf den Startbefehl
rc=0

while (( $rc == 0 || $rc == 10 || $rc == 12 || $rc == 14 || $rc == 15 )); do

	echo -e "\033[42m\033[30mMAIN START======================================================================\033[49m\033[39m"

	killall -9 php
	echo "EDOMI starten..."
	php $MAIN_PATH/main/proc/proc_main.php $rc
	rc=$?
	killall -9 php

	echo -e "\033[42m\033[30mMAIN ENDE=======================================================================\033[49m\033[39m"

	if (( $rc == 10 )); then
		echo "EDOMI: Neustart und Pausieren..."
	fi

	if (( $rc == 12 )); then
		echo "EDOMI: Neustart und Durchstarten..."
	fi

	if (( $rc == 14 || $rc == 15 )); then
		echo "EDOMI: Neustart, Projektaktivierung und Pausieren..."
	fi
 
done
       
if (( $rc == 13 )); then
	echo -e "\033[41m\033[30m Server wird in 5s neu gestartet...                       (Abbrechen mit ENTER) \033[49m\033[39m"
	read -t 5
	userkey=$?
	if (( $userkey == 0 )); then
		echo "Reboot wurde abgebrochen"
		exit
	else
		echo "Server: Reboot..."
		reboot
		exit
	fi
fi

if (( $rc == 21 )); then
	echo "EDOMI: Restore..."
	sleep 5s

	if [ -f /tmp/edomirestore.data ]; then
		
		sh /tmp/edomirestore.sh &
		echo "EDOMI: Beenden..."
		exit
	
	fi

	echo "Es wurde keine Restore-Datei gefunden!"
	echo -e "\033[41m\033[30m Server wird in 5s neu gestartet...                       (Abbrechen mit ENTER) \033[49m\033[39m"
	read -t 5
	userkey=$?
	if (( $userkey == 0 )); then
		echo "Reboot wurde abgebrochen"
		exit
	else
		echo "Server: Reboot..."
		reboot
		exit
	fi
fi

if (( $rc == 22 )); then
	echo "EDOMI: Beenden..."
	exit
fi

if (( $rc == 23 )); then
	echo -e "\033[41m\033[30m Server wird in 5s ausgeschaltet...                       (Abbrechen mit ENTER) \033[49m\033[39m"
	read -t 5
	userkey=$?
	if (( $userkey == 0 )); then
		echo "Shutdown wurde abgebrochen"
		exit
	else
		echo "Server: Shutdown..."
		shutdown -h now
		exit
	fi
fi

if (( $rc == 24 )); then
	echo "EDOMI: Update..."
	sleep 5s

	if [ -f /tmp/edomiupdate.data ]; then
		
		sh /tmp/edomiupdate.sh &
		echo "EDOMI: Beenden..."
		exit
	
	fi

	echo "Es wurde keine Update-Datei gefunden!"
	echo -e "\033[41m\033[30m Server wird in 5s neu gestartet...                       (Abbrechen mit ENTER) \033[49m\033[39m"
	read -t 5
	userkey=$?
	if (( $userkey == 0 )); then
		echo "Reboot wurde abgebrochen"
		exit
	else
		echo "Server: Reboot..."
		reboot
		exit
	fi
fi

# Server-Neustart (Fallback)
echo -e "\033[41m\033[30m--------------------------------------------------------------------------------\033[49m\033[39m"
echo -e "\033[41m\033[30m Unbekannter Fehler! Server wird in 30s neu gestartet...  (Abbrechen mit ENTER) \033[49m\033[39m"
echo -e "\033[41m\033[30m--------------------------------------------------------------------------------\033[49m\033[39m"
read -t 30
userkey=$?
if (( $userkey == 0 )); then
	echo "Reboot wurde abgebrochen"
	exit
else
	echo "Server: Reboot..."
	reboot
	exit
fi
