<?
/* 
 * EDOMI beta (Version 1.50) - Intelligente Steuerung und Visualisierung KNX-basierter Elektro-Installationen.
 * @link http://www.edomi.de 
 * @author Dr. Christian Gärtner <dr.christian.gaertner@googlemail.com> 
 * @copyright 2015,2016,2017 Dr. Christian Gärtner 
 * @license Freeware 
 *
 *     This file and all other files are part of EDOMI.
 *
 *     EDOMI is distributed in the hope that it will be useful,
 *     but WITHOUT ANY WARRANTY; without even the implied warranty of
 *     MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 *
 *     Diese und alle anderen Dateien sind Teil von EDOMI.
 *
 *     EDOMI wird in der Hoffnung, dass es nützlich sein wird, aber
 *     OHNE JEDE GEWÄHRLEISTUNG, bereitgestellt; sogar ohne die implizite
 *     Gewährleistung der MARKTFÄHIGKEIT oder EIGNUNG FÜR EINEN BESTIMMTEN ZWECK.
*/ 
?><?
//Globale Includes
require("../../shared/php/config.php");
require(MAIN_PATH."/www/shared/php/base.php");
require(MAIN_PATH."/www/shared/php/incl_http.php");

//Eigene Includes
require(MAIN_PATH."/www/admin/include/php/config.php");
require(MAIN_PATH."/www/admin/include/php/base.php");
require(MAIN_PATH."/www/admin/include/php/incl_items.php");


sql_connect();

if (checkAdmin($sid)) {cmd($cmd);}

function cmd($cmd) {
	global $appId,$winId,$data,$dataArr,$phpdata,$phpdataArr,$sid;

	if ($cmd=='initApp') {

		//Existiert ein aktuelles Projekt?
		if (getEditProjektId()===false) {
?>
			closeWindow("<?echo $winId;?>");
			jsConfirm("Es ist kein Arbeitsprojekt vorhanden.","","none");
<?
			return;
		}

		//Fenster aufbauen
?>
		var n="<div id='<?echo $winId;?>-global' class='appWindowFullscreen' onMouseUp='app2_itemPageUnclick();' data-copybuffer=''>";
			n+="<div class='appTitel'>Visueditor<div class='cmdHelp' onClick='openWindow(9999,\"<?echo $appId;?>\");'>?</div></div>";
			n+="<div id='<?echo $winId;?>-main'></div>";
			n+="<div id='<?echo $winId;?>-menu' class='controlEditInline' style='position:absolute; background:#ffffff; margin:0 5px 5px 5px; padding:0px; left:0px; width:230px; top:80px; bottom:0px;'></div>";
			n+="<div id='<?echo $winId;?>-pagecontainer' class='app2_pageContainer' style='left:242px;'>";
				n+="<div id='<?echo $winId;?>-page' class='app2_page' onMouseDown='app2_itemPageClick();' onMouseMove='app2_itemPageMouseMove();'></div>";
			n+="</div>";
		n+="</div>";
		document.getElementById("<?echo $winId;?>").innerHTML=n;
<?
		//Menü aufbauen
?>
		var n="<div class='appMenu'>";
			n+="<div class='cmdButton' onClick='app2_quit(\"<?echo $winId;?>\");'>Schliessen</div>";
			n+="&nbsp;&nbsp;&nbsp;";
			n+="<div id='<?echo $winId;?>-fd1' data-type='1000' data-root='22' data-value='0' data-options='typ=1;reset=0;caption=Visuseite öffnen' data-callback='app2_pickPage_callback(\"<?echo $winId;?>-fd1\");' data-callback2='app2_pickPage_callback(\"<?echo $winId;?>-fd1\");' class='cmdButton' style='min-width:100px; max-width:500px; white-space:nowrap; overflow:hidden; vertical-align:top;'>&nbsp;</div>";
			n+="&nbsp;&nbsp;&nbsp;";

			n+="<div id='<?echo $winId;?>-rasterx' class='cmdButton' value='1' onClick='app2_gridXtoggle();'>RasterX: 1</div>";
			n+="<div id='<?echo $winId;?>-rastery' class='cmdButton' value='1' onClick='app2_gridYtoggle();'>RasterY: 1</div>";
			n+="<div id='<?echo $winId;?>-position' class='cmdButton' onClick='app2_moveElementsByKeyboard();'>(X/Y)</div>";
			n+="&nbsp;&nbsp;&nbsp;";

			n+="<div id='<?echo $winId;?>-fd2' data-type='1000' data-root='24' data-value='0' data-options='typ=5;caption=Designvorlagen' data-callback2='app2_refreshAll(0);' class='cmdButton'>&nbsp;</div>";
			n+="&nbsp;&nbsp;&nbsp;";

			n+="<div id='<?echo $winId;?>-preview' class='cmdButton' onClick='app2_previewModeToggle();'>Vorschau</div>";
			n+="<input type='text' id='<?echo $winId;?>-previewValue' class='control1' onChange='app2_previewChangeValue(this);' placeholder='KO-Wert' value='' style='height:27px; display:none;'></input>";

			n+="<div style='vertical-align:middle; float:right;'>";
				n+="<div id='<?echo $winId;?>-zoom' style='display:inline;'>100%</div>";
				n+="<input type='range' value='1' min='0.5' max='2' step='0.1' onInput='app2_zoom(this.value);' onDblClick='app2_zoom(1); this.value=1;' style='width:120px; vertical-align:middle;'></input>";
				n+="&nbsp;&nbsp;&nbsp;";
				n+="<div id='<?echo $winId;?>-layer' class='cmdButton' onClick='app2_setLayerMode();'><img src='../shared/img/lock1.png' width='16' height='16' valign='middle' style='margin:0; padding-left:2px;' draggable='false'></div>";
			n+="</div>";
		n+="</div>";
		document.getElementById("<?echo $winId;?>-main").innerHTML=n;
		controlInitAll("<?echo $winId;?>-main");
		controlClickLeft("<?echo $winId;?>-fd1"); //Visuseite auswählen
		app2_init("<?echo $winId;?>");
<?
	}


	if ($cmd=='start') {
		if ($dataArr[0]>0) {
?>
			clearObject(app2_winId+"-page",0);
			clearObject(app2_winId+"-menu",0);
<?
			//Visu/Page-Daten holen
			$page=sql_getValues('edomiProject.editVisuPage','*','id='.$dataArr[0]);		
			if ($page!==false) {
				$visu=sql_getValues('edomiProject.editVisu','*','id='.$page['visuid']);
			}
			
			//Seite aufbauen
			if ($visu['id']>0 && $page['id']>0) {
				$imageCachingSuffix='?'.date('YmdHis');
?>
				document.getElementById("<?echo $winId;?>-rasterx").value="<?echo $page['xgrid'];?>";
				document.getElementById("<?echo $winId;?>-rasterx").innerHTML="RasterX: <?echo $page['xgrid'];?>";
				document.getElementById("<?echo $winId;?>-rastery").value="<?echo $page['ygrid'];?>";
				document.getElementById("<?echo $winId;?>-rastery").innerHTML="RasterY: <?echo $page['ygrid'];?>";
<?
				//Container erstellen
?>
				var pdiv=document.getElementById("<?echo $winId;?>-page");
				var vp=app2_newDiv(pdiv,"<?echo $winId;?>-visupage");
				vp.className="app2_visuPage";
<?
				if ($page['pagetyp']==1) {	//Popup
?>
					vp.style.width="<?echo $page['xsize'];?>px";
					vp.style.height="<?echo $page['ysize'];?>px";
<?
				} else {					//Normal/Global
?>
					vp.style.width="<?echo $visu['xsize'];?>px";
					vp.style.height="<?echo $visu['ysize'];?>px";
<?
				}

				//Fonts einfügen
?>
				var n="";
<?
				$ss2=sql_call("SELECT * FROM edomiProject.editVisuFont");
				while ($n=sql_result($ss2)) {
					if ($n['fonttyp']==1) {	//Custom-Font
?>
						n+="@font-face {font-family:'font<?echo $n['id'];?>'; font-style:<?if ($n['fontstyle']==0) {echo 'normal';} else {echo 'italic';}?>; font-weight:<?if ($n['fontweight']==0) {echo 'normal';} else {echo 'bold';}?>; src:url('../../data/project/visu/etc/font-<?echo $n['id'];?>.ttf?<?echo $n['fontname'];?>') format('truetype');}\n";
<?
					} else {				//System-Font
?>
						n+="@font-face {font-family:'font<?echo $n['id'];?>'; src:local('<?ajaxEcho($n['fontname']);?>');}\n";
<?
					}
				}
?>
				document.getElementById("cssFonts").innerHTML=n;
<?
				//Inklude-Verkettung auflösen (einschließlich aktueller Seite)
				$pageIncludeIDs=array($page['id']);	//aktuelle Visuseite
				if ($page['pagetyp']==0) {

					//Inklude-Seiten:
					$tmp=$page['includeid'];		//Start-IncludeId der aktuellen Visuseite				
					while (!isEmpty($tmp) && is_numeric($tmp) && $tmp>0 && !in_array($tmp,$pageIncludeIDs)) {
						array_unshift($pageIncludeIDs,$tmp);
						$ss1=sql_call("SELECT includeid FROM edomiProject.editVisuPage WHERE id=".$tmp);
						$tmp=0;
						if ($n=sql_result($ss1)) {
							if (!isEmpty($n['includeid']) && is_numeric($n['includeid']) && $n['includeid']>0) {
								$tmp=$n['includeid'];
							} else {
								$tmp=0;
							}
						}
						sql_close($ss1);
					}

					if ($page['globalinclude']==1) {
						//Globale Inkludeseiten:
						$ss1=sql_call("SELECT id FROM edomiProject.editVisuPage WHERE (visuid=".$visu['id']." AND pagetyp=2 AND id<>".$page['id'].") ORDER BY id DESC");
						while ($n=sql_result($ss1)) {
							array_unshift($pageIncludeIDs,$n['id']);
						}
						sql_close($ss1);
					}
				}
				$currentPageIDs=implode(',',$pageIncludeIDs);

				//Seiten-Hintergrund
				$tmp1='';
				$tmp2='';
				$ss1=sql_call("SELECT bgimg,bgcolorid FROM edomiProject.editVisuPage WHERE (id IN (".$currentPageIDs.")) ORDER BY FIELD(id,".$currentPageIDs.") DESC");
				while ($nn=sql_result($ss1)) {
					if (isEmpty($tmp1) && $nn['bgimg']>=1) {
						$ss2=sql_call("SELECT id,suffix FROM edomiProject.editVisuImg WHERE (id=".$nn['bgimg'].")");
						if ($n=sql_result($ss2)) {$tmp1="url('../data/project/visu/img/img-".$n['id'].".".$n['suffix'].$imageCachingSuffix."')";}
						sql_close($ss2);
					}
					if (isEmpty($tmp2) && $nn['bgcolorid']>=1) {$tmp2=sql_getValue('edomiProject.editVisuBGcol','color',"id='".$nn['bgcolorid']."'");}
				}
				sql_close($ss1);
				$tmp=trim(($tmp1.','.$tmp2),',');
				if (!isEmpty($tmp)) {
?>
					vp.style.background="<?ajaxEcho($tmp);?>";
					vp.style.backgroundSize="100% 100%";
					vp.style.backgroundRepeat="no-repeat";
<?
				}

				//Visuelemente
				$ss1=sql_call("SELECT * FROM edomiProject.editVisuElement WHERE (pageid IN (".$currentPageIDs.")) ORDER BY FIELD(pageid,".$currentPageIDs.") ASC,(controltyp=255) DESC,id ASC");
				while ($item=sql_result($ss1)) {								
?>
					var ve=new class_app2_VE();
					ve.element={id:"<?echo $item['id'];?>",pageid:"<?echo $item['pageid'];?>",controltyp:"<?echo $item['controltyp'];?>",groupid:"<?echo $item['groupid'];?>",layer:"<?echo $item['layer'];?>",name:"<?ajaxEcho($item['name']);?>",text:"<?echo ajaxValueHTML($item['text']);?>",menutext:"<?ajaxEcho($item['text']);?>"};
<?
					if ($item['controltyp']==255) {
						//Gruppenelement-Container
						if ($item['pageid']==$page['id']) {	//Include-Elemente ignorieren (spart hier nur Ajax-Ressourcen - JS prüft dies ohnehin nochmal)
?>
							ve.addGroup();
<?
						}
					} else {							
						//normales Visuelement
?>
						ve.addElement();
<?
						app2_setElementStyle($item,$imageCachingSuffix);
						$tmp=app2_getElementProperties($item);
?>
						ve.createElement({p0:"<?echo $tmp[0];?>",p1:"<?echo $tmp[1];?>",p2:"<?echo $tmp[2];?>",p3:"<?echo $tmp[3];?>"});
<?
					}
				}
?>
				app2_groupBoundingBoxes();
				app2_restoreState("<?echo $phpdataArr[0];?>");
<?
			}
		}
	}

	if ($cmd=='saveElementsPosition') {
		$tmp=explode(';',$phpdataArr[0]);
		foreach ($tmp as $n) {
			$element=explode(',',$n);
			if ($element[0]>0) {
				sql_call("UPDATE edomiProject.editVisuElement SET xpos='".$element[1]."',ypos='".$element[2]."' WHERE (id=".$element[0]." AND controltyp<>255)");
			}
		}
	}

	if ($cmd=='layerElements') {
		$tmp=explode(';',$phpdataArr[0]);
		foreach ($tmp as $element) {
			if ($element>0) {
				sql_call("UPDATE edomiProject.editVisuElement SET layer='".$phpdataArr[1]."' WHERE id=".$element);
			}
		}
?>
		app2_refreshAll(0);
<?	
	}

	if ($cmd=='incElementsZindex') {
		$tmp=explode(';',$phpdataArr[0]);
		foreach ($tmp as $element) {
			if ($element>0) {
				sql_call("UPDATE edomiProject.editVisuElement SET zindex=zindex+1 WHERE (id=".$element." AND zindex<99999 AND controltyp<>255)");
			}
		}
?>
		app2_refreshAll(0);
<?	
	}

	if ($cmd=='decElementsZindex') {
		$tmp=explode(';',$phpdataArr[0]);
		foreach ($tmp as $element) {
			if ($element>0) {
				sql_call("UPDATE edomiProject.editVisuElement SET zindex=zindex-1 WHERE (id=".$element." AND zindex>0 AND controltyp<>255)");
			}
		}
?>
		app2_refreshAll(0);
<?	
	}

	if ($cmd=='deleteElements') {
		$tmp=explode(';',$phpdataArr[0]);
		foreach ($tmp as $element) {
			if ($element>0) {
				sql_call("DELETE FROM edomiProject.editVisuElementDesign WHERE (targetid=".$element.")");
				sql_call("DELETE FROM edomiProject.editVisuCmdList WHERE (targetid=".$element.")");
				sql_call("DELETE FROM edomiProject.editVisuElement WHERE (id=".$element.")");
			}
		}

		//groupid bei Elementen löschen, wenn die zugehörige Gruppe nicht mehr vorhanden ist (für den Fall, dass nur die Gruppe gelöscht wurde - ohne Inhalt)
		$ss1=sql_call("SELECT id FROM edomiProject.editVisuElement WHERE groupid>0 AND groupid NOT IN (SELECT id FROM edomiProject.editVisuElement WHERE controltyp=255)");
		while ($n=sql_result($ss1)) {
			sql_call("UPDATE edomiProject.editVisuElement SET groupid=0 WHERE id=".$n['id']);
		}
		sql_close($ss1);
?>
		app2_refreshAll(0);
<?	
	}

	if ($cmd=='pasteElements') {
		//Dupliziert die Elemente (z.B. aus dem Copypaste-Buffer) auf die aktuelle(!) Seite

		//VisuId der Zielseite:
		$visuId=sql_getValue('edomiProject.editVisuPage','visuid','id='.$dataArr[0]);

		//Elemente duplizieren
		if ($visuId>0) {
			$tmp=explode(';',$phpdataArr[0]);
			$newElements=db_itemDuplicate_editVisuElement($visuId,$dataArr[0],$tmp,'-KOPIE');
?>
			app2_refreshAll(0,"<?echo implode(';',$newElements);?>");
<?	
		}
	}

	if ($cmd=='moveElements') {
		//Verschiebt die Elemente aus dem Copypaste-Buffer auf die aktuelle(!) Seite

		//VisuId der Zielseite:
		$visuId=sql_getValue('edomiProject.editVisuPage','visuid','id='.$dataArr[0]);

		//Elemente verschieben 
		if ($visuId>0) {

			$newElements=array();
			$tmp=explode(';',$phpdataArr[0]);
			foreach ($tmp as $element) {
				if ($element>0) {
					
					$groupId=sql_getValue('edomiProject.editVisuElement','groupid','id='.$element.' AND controltyp<>255');
					if ($groupId>0) {
						//wenn die zugehörige Gruppe nicht im Array ist: groupid des Elements beim Update löschen
						if (array_search($groupId,$tmp)===false) {$groupId=0;}
					}
					
					sql_call("UPDATE edomiProject.editVisuElement SET visuid='".$visuId."',pageid='".$dataArr[0]."',groupid=".sql_encodeValue($groupId,true)." WHERE id=".$element);
					$newElements[]=$element;
				}
			}
			
			//groupid bei Elementen löschen, wenn die zugehörige Gruppe nicht mehr auf der gleichen Visuseite vorhanden ist
			$ss1=sql_call("SELECT id,pageid FROM edomiProject.editVisuElement WHERE controltyp=255");
			while ($n=sql_result($ss1)) {
				sql_call("UPDATE edomiProject.editVisuElement SET groupid=0 WHERE groupid=".$n['id']." AND pageid<>".$n['pageid']);
			}
			sql_close($ss1);
?>
			app2_refreshAll(0,"<?echo implode(';',$newElements);?>");
<?	
		}
	}

	if ($cmd=='createGroup') {
		//Selektion gruppieren (neue Gruppe erstellen)
		
		//VisuId der Zielseite:
		$visuId=sql_getValue('edomiProject.editVisuPage','visuid','id='.$dataArr[0]);

		if ($visuId>0) {
		
			$tmp=explode(';',$phpdataArr[0]);
			$err=false;
			foreach ($tmp as $element) {
				if ($element>0) {
					$n=sql_getValue('edomiProject.editVisuElement','id','id='.$element.' AND (groupid>0 OR controltyp=255)');
					if ($n>0) {
						$err=true;
						break;
					}
				}
			}
			
			if (!$err) {
				$newElements=array();
				
				//Gruppenelement erzeugen
				$dbId=db_itemSave('editVisuElement',array(
					1	=>	-1,
					6	=>	255,
					20	=>	'Neue Gruppe',
					97	=>	$visuId,
					98	=>	$dataArr[0]
				));
				
				if ($dbId>0) {
					$newElements[]=$dbId;
					foreach ($tmp as $element) {
						if ($element>0) {
							sql_call("UPDATE edomiProject.editVisuElement SET groupid=".$dbId." WHERE id=".$element);
							$newElements[]=$element;
						}
					}
				}
?>
				app2_refreshAll(0,"<?echo implode(';',$newElements);?>");
<?	
			} else {
?>
				jsConfirm("Gruppen oder Elemente einer Gruppe können nicht erneut gruppiert werden.","","none");
<?
			}
			
		}
	}

	if ($cmd=='uncreateGroup') {
		//Elemente der Gruppe auflösen
		sql_call("UPDATE edomiProject.editVisuElement SET groupid=0 WHERE (groupid='".$phpdataArr[0]."')");
		//Gruppenelement löschen
		sql_call("DELETE FROM edomiProject.editVisuElement WHERE (id='".$phpdataArr[0]."')");
?>
		app2_refreshAll(0);
<?	
	}

}


sql_disconnect();



function app2_setElementStyle($item,$imageCachingSuffix) {
	//Defaultdesign holen
	$ss2=sql_call("SELECT * FROM edomiProject.editVisuElementDesign WHERE (targetid=".$item['id']." AND styletyp=0)");
	if ($design=sql_result($ss2)) {
		//Designvorlage?
		if ($design['defid']>0) {
			$ss3=sql_call("SELECT * FROM edomiProject.editVisuElementDef WHERE (id=".$design['defid'].")");
			if ($tmp=sql_result($ss3)) {
				for ($t=1;$t<=48;$t++) {
					if (!isEmpty($design['s'.$t])) {$tmp['s'.$t]=$design['s'.$t];}
				}
				$design=$tmp;
			}
			sql_close($ss3);
		}
	}
	sql_close($ss2);

	//Padding=0 erzwingen für einige Visuelemente
	if (in_array($item['controltyp'],array(11,12,13,14,15,16,17,20,21,22,23,24,25,26,27,28,29,30,31,32))) {$design['s12']=null;}

	//Text-Align=center erzwingen für einige Visuelemente
	if (in_array($item['controltyp'],array(11,12,13,16,17,20,21,22,23,24,25,26,27,28,29,30,31,32))) {$design['s18']=2;}
?>
	ve.item.style.overflow="hidden";
	ve.item.style.zIndex="<?echo $item['zindex'];?>";
<?
	//effektive Position berechnen (Translation addieren)
?>
	var x=parseInt("<?ajaxEcho($item['xpos']);?>");
	var y=parseInt("<?ajaxEcho($item['ypos']);?>");
	var tmp=parseInt(app2_previewGetCSS("<?ajaxEcho($design['s3']);?>"));
	if (!isNaN(tmp)) {x+=tmp; ve.item.dataset.translatex=tmp;} else {ve.item.dataset.translatex=0;}
	var tmp=parseInt(app2_previewGetCSS("<?ajaxEcho($design['s4']);?>"));
	if (!isNaN(tmp)) {y+=tmp; ve.item.dataset.translatey=tmp;} else {ve.item.dataset.translatey=0;}
	ve.item.style.left=x+"px";
	ve.item.style.top=y+"px";
<?

	//effektive Größe berechnen
?>
	var w=parseInt("<?ajaxEcho($item['xsize']);?>");
	var h=parseInt("<?ajaxEcho($item['ysize']);?>");
<?
	//Padding abziehen
	if ($design['s18']=='1' || $design['s18']=='3') {
?>
		var tmp=parseInt(app2_previewGetCSS("<?ajaxEcho($design['s12']);?>"));
		if (!isNaN(tmp)) {w-=tmp;}
<?
	}
	if ($design['s18']=='2' || $design['s18']=='4') {
?>
		var tmp=parseInt(app2_previewGetCSS("<?ajaxEcho($design['s12']);?>"));
		if (!isNaN(tmp)) {w-=2*tmp;}
<?
	}
	//Border abziehen
?>
	var tmp=parseInt(app2_previewGetCSS("<?ajaxEcho($design['s31']);?>"));
<?
	if ($design['s27']>=1) {?> if (!isNaN(tmp)) {w-=tmp;} <? }
	if ($design['s28']>=1) {?> if (!isNaN(tmp)) {h-=tmp;} <? }
	if ($design['s29']>=1) {?> if (!isNaN(tmp)) {w-=tmp;} <? }
	if ($design['s30']>=1) {?> if (!isNaN(tmp)) {h-=tmp;} <? }

	//Skalierung addieren
?>
	var tmp=parseInt(app2_previewGetCSS("<?ajaxEcho($design['s5']);?>"));
	if (!isNaN(tmp)) {w+=tmp;}
	var tmp=parseInt(app2_previewGetCSS("<?ajaxEcho($design['s6']);?>"));
	if (!isNaN(tmp)) {h+=tmp;}

	ve.item.style.width=w+"px";
	ve.item.style.height=h+"px";
<?


	//individuelle CSS-Eigenschaften (muss am Anfang definiert werden, sonst werden manche Design-Eigenschaften ignoriert...)
	if (!isEmpty($design['s48'])) {?> ve.item.style.cssText+=app2_previewGetCSS("<?ajaxEcho($design['s48']);?>"); <? }

	//Text
	if ($design['s13']>0) {?> ve.item.style.fontFamily="font<?echo $design['s13'];?>"; <? } else {?> ve.item.style.fontFamily="<?ajaxEcho(global_visuFont);?>"; <? }

	if ($design['s14']!='') {?> ve.item.style.fontSize=app2_previewGetCSS("<?ajaxEcho($design['s14']);?>")+"px"; <? }
	
	if ($design['s15']!='') {?> ve.item.style.color=app2_previewGetCSS("<?ajaxEcho(sql_getValue('edomiProject.editVisuFGcol','color',"id='".$design['s15']."'"));?>"); <? }

	if ($design['s16']!='') {$tmp=array(1=>'normal',2=>'italic');?> ve.item.style.fontStyle="<?ajaxEcho($tmp[$design['s16']]);?>"; <? }
	if ($design['s17']!='') {$tmp=array(1=>'normal',2=>'bold');?> ve.item.style.fontWeight="<?ajaxEcho($tmp[$design['s17']]);?>"; <? }
	
	if ($design['s18']=='1') {?> ve.item.style.textAlign="left"; <? }
	if ($design['s18']=='2') {?> ve.item.style.textAlign="center"; <? }
	if ($design['s18']=='3') {?> ve.item.style.textAlign="right"; <? }
	if ($design['s18']=='4') {?> ve.item.style.textAlign="justify"; <? }

	if ($design['s12']!='' && ($design['s18']=='1' || $design['s18']=='2' || $design['s18']=='4')) {?> ve.item.style.paddingLeft=app2_previewGetCSS("<?ajaxEcho($design['s12']);?>px"); <? }
	if ($design['s12']!='' && ($design['s18']=='3' || $design['s18']=='2' || $design['s18']=='4')) {?> ve.item.style.paddingRight=app2_previewGetCSS("<?ajaxEcho($design['s12']);?>px"); <? }

	if ($design['s19']!='' && $design['s20']!='' && $design['s21']!='' && $design['s22']!='') {?> ve.item.style.textShadow=app2_previewGetCSS("<?ajaxEcho($design['s19']);?>")+"px "+app2_previewGetCSS("<?ajaxEcho($design['s20']);?>")+"px "+app2_previewGetCSS("<?ajaxEcho($design['s21']);?>")+"px "+app2_previewGetCSS("<?ajaxEcho(sql_getValue('edomiProject.editVisuFGcol','color',"id='".$design['s22']."'"));?>"); <? }

	if ($design['s7']!='') {?> ve.item.style.WebkitTransform="rotate("+app2_previewGetCSS("<?ajaxEcho($design['s7']);?>")+"deg)"; <? }

	//Opazität: Nur im Preview-Modus setzen
	if ($design['s8']!='') {?> if (app2_previewMode) {ve.item.style.opacity=app2_previewGetCSS("<?ajaxEcho($design['s8']);?>");} <? }

	//Hintergrund (Bild und Farbe)
	$tmp='';
	if ($design['s10']>0) {
		$ss2=sql_call("SELECT * FROM edomiProject.editVisuImg WHERE (id=".$design['s10'].")");
		if ($n=sql_result($ss2)) {
			$tmp.="url('../data/project/visu/img/img-".$n['id'].".".$n['suffix'].$imageCachingSuffix."')";
?>
			ve.appendToMenuItemCaption(" <span style='color:#909090;'>[<?ajaxEcho($n['name']);?> <span class='id'><?ajaxEcho($n['id']);?></span>]</span>");
<?
		}
	}
	if ($design['s9']>0) {
		if (!isEmpty($tmp)) {$tmp.=',';}
		$tmp.=sql_getValue('edomiProject.editVisuBGcol','color',"id='".$design['s9']."'");
	}
	if (!isEmpty($tmp)) {
?>
		ve.item.style.background=app2_previewGetCSS("<?ajaxEcho($tmp);?>");
<?
		if ($item['controltyp']==2) {	//Bildelement?
			if ($item['var1']==1) {?> ve.item.style.backgroundSize="<?ajaxEcho($item['var3']);?>px <?ajaxEcho($item['var4']);?>px"; <? }
			if ($item['var1']==2) {?> ve.item.style.backgroundSize="100% 100%"; <? }
			if ($item['var1']==3) {?> ve.item.style.backgroundSize="cover"; <? }
			if ($item['var1']==4) {?> ve.item.style.backgroundSize="contain"; <? }						
			if ($item['var2']==0) {?> ve.item.style.backgroundRepeat="no-repeat"; <? }
			if ($item['var2']==1) {?> ve.item.style.backgroundRepeat="repeat-x"; <? }
			if ($item['var2']==2) {?> ve.item.style.backgroundRepeat="repeat-y"; <? }
			if ($item['var2']==3) {?> ve.item.style.backgroundRepeat="repeat"; <? }							
		} else {
?>
			ve.item.style.backgroundSize="100% 100%";
			ve.item.style.backgroundRepeat="no-repeat";
<?
		}
	}
	
	if (!isEmpty($design['s23'])) {?> ve.item.style.borderTopLeftRadius=app2_previewGetCSS("<?ajaxEcho($design['s23']);?>")+"px"; <? }
	if (!isEmpty($design['s24'])) {?> ve.item.style.borderTopRightRadius=app2_previewGetCSS("<?ajaxEcho($design['s24']);?>")+"px"; <? }
	if (!isEmpty($design['s25'])) {?> ve.item.style.borderBottomRightRadius=app2_previewGetCSS("<?ajaxEcho($design['s25']);?>")+"px"; <? }
	if (!isEmpty($design['s26'])) {?> ve.item.style.borderBottomLeftRadius=app2_previewGetCSS("<?ajaxEcho($design['s26']);?>")+"px"; <? }

	$tmp='none';
	if ($design['s32']=='1') {$tmp='solid';}
	if ($design['s32']=='2') {$tmp='dotted';}
	if ($design['s32']=='3') {$tmp='dashed';}

	if ($design['s27']>=1) {?> ve.item.style.borderLeft=app2_previewGetCSS("<?ajaxEcho($design['s31']);?>")+"px <?echo $tmp;?> "+app2_previewGetCSS("<?ajaxEcho(sql_getValue('edomiProject.editVisuFGcol','color',"id='".$design['s27']."'"));?>"); <? }
	if ($design['s28']>=1) {?> ve.item.style.borderTop=app2_previewGetCSS("<?ajaxEcho($design['s31']);?>")+"px <?echo $tmp;?> "+app2_previewGetCSS("<?ajaxEcho(sql_getValue('edomiProject.editVisuFGcol','color',"id='".$design['s28']."'"));?>"); <? }
	if ($design['s29']>=1) {?> ve.item.style.borderRight=app2_previewGetCSS("<?ajaxEcho($design['s31']);?>")+"px <?echo $tmp;?> "+app2_previewGetCSS("<?ajaxEcho(sql_getValue('edomiProject.editVisuFGcol','color',"id='".$design['s29']."'"));?>"); <? }
	if ($design['s30']>=1) {?> ve.item.style.borderBottom=app2_previewGetCSS("<?ajaxEcho($design['s31']);?>")+"px <?echo $tmp;?> "+app2_previewGetCSS("<?ajaxEcho(sql_getValue('edomiProject.editVisuFGcol','color',"id='".$design['s30']."'"));?>"); <? }

	if ($design['s33']!='' && $design['s34']!='' && $design['s35']!='' && $design['s36']!='' && $design['s37']!='' && $design['s38']!='') {?> ve.item.style.boxShadow=app2_previewGetCSS("<?ajaxEcho($design['s33']);?>")+"px "+app2_previewGetCSS("<?ajaxEcho($design['s34']);?>")+"px "+app2_previewGetCSS("<?ajaxEcho($design['s35']);?>")+"px "+app2_previewGetCSS("<?ajaxEcho($design['s36']);?>")+"px "+app2_previewGetCSS("<?ajaxEcho(sql_getValue('edomiProject.editVisuFGcol','color',"id='".$design['s37']."'"));?>")+" <?if ($design['s38']==2) {echo 'inset';};?>"; <? }
}

function app2_getElementProperties($item) {
	$r=array();
	
	if ($item['controltyp']==14) {
		$r[]=ajaxValueHTML($item['var10']);

	} else if ($item['controltyp']==16) {
		$r[]=ajaxValueHTML($item['var10']);

	} else if ($item['controltyp']==20) {
		$cap1=sql_getValue('edomiProject.editCam','name','id='.$item['var1']);
		$cap2=sql_getValue('edomiProject.editArchivCam','name','id='.$item['var3']);
		$r[]=ajaxValueHTML($item['var10']);
		$r[]=ajaxValueHTML($cap1);
		$r[]=ajaxValueHTML($cap2);
		$r[]=ajaxEncode($cap1).((!isEmpty($cap2))?ajaxEncode(' / '.$cap2):'');

	} else if ($item['controltyp']==21) {
		$cap1=sql_getValue('edomiProject.editChart','name','id='.$item['var1']);
		$r[]=ajaxValueHTML($cap1);
		$r[]=ajaxEncode($cap1);

	} else if ($item['controltyp']==22) {
		$cap1=sql_getValue('edomiProject.editTimer','name','id='.$item['var1']);
		$r[]=ajaxValueHTML($item['var10']);
		$r[]=ajaxValueHTML($cap1);
		$r[]=ajaxEncode($cap1);

	} else if ($item['controltyp']==23) {
		$cap1=sql_getValue('edomiProject.editAws','name','id='.$item['var1']);
		$r[]=ajaxValueHTML($item['var10']);
		$r[]=ajaxValueHTML($cap1);
		$r[]=ajaxEncode($cap1);

	} else if ($item['controltyp']==25) {
		$cap1=sql_getValue('edomiProject.editArchivMsg','name','id='.$item['var1']);
		$r[]=ajaxValueHTML($item['var10']);
		$r[]=ajaxValueHTML($cap1);
		$r[]=ajaxEncode($cap1);

	} else if ($item['controltyp']==26) {
		$cap1=sql_getValue('edomiProject.editArchivKo','name','id='.$item['var1']);
		$r[]=ajaxValueHTML($item['var10']);
		$r[]=ajaxValueHTML($cap1);
		$r[]=ajaxEncode($cap1);

	} else if ($item['controltyp']==28) {
		$cap1=sql_getValue('edomiProject.editArchivPhone','name','id='.$item['var1']);
		$r[]=ajaxValueHTML($item['var10']);
		$r[]=ajaxValueHTML($cap1);
		$r[]=ajaxEncode($cap1);

	} else if ($item['controltyp']==32) {
		$cap1=sql_getValue('edomiProject.editAgenda','name','id='.$item['var1']);
		$r[]=ajaxValueHTML($item['var10']);
		$r[]=ajaxValueHTML($cap1);
		$r[]=ajaxEncode($cap1);
	}

	return $r;
}
?>

