<?
/* 
 * EDOMI beta (Version 1.50) - Intelligente Steuerung und Visualisierung KNX-basierter Elektro-Installationen.
 * @link http://www.edomi.de 
 * @author Dr. Christian Gärtner <dr.christian.gaertner@googlemail.com> 
 * @copyright 2015,2016,2017 Dr. Christian Gärtner 
 * @license Freeware 
 *
 *     This file and all other files are part of EDOMI.
 *
 *     EDOMI is distributed in the hope that it will be useful,
 *     but WITHOUT ANY WARRANTY; without even the implied warranty of
 *     MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 *
 *     Diese und alle anderen Dateien sind Teil von EDOMI.
 *
 *     EDOMI wird in der Hoffnung, dass es nützlich sein wird, aber
 *     OHNE JEDE GEWÄHRLEISTUNG, bereitgestellt; sogar ohne die implizite
 *     Gewährleistung der MARKTFÄHIGKEIT oder EIGNUNG FÜR EINEN BESTIMMTEN ZWECK.
*/ 
?><?
//Globale Includes
require("../../shared/php/config.php");
require(MAIN_PATH."/www/shared/php/base.php");
require(MAIN_PATH."/www/shared/php/incl_http.php");

//Eigene Includes
require(MAIN_PATH."/www/visu/include/php/config.php");
require(MAIN_PATH."/www/visu/include/php/base.php");


sql_connect();


$visuCmd=checkVisuSid($visuId,$sid,true);
if ($cmd=='login' || $visuCmd) {
	cmd($cmd,$visuCmd);
} else {
	$html="<option value='0'>Visualisierung</option>";
	$ss1=sql_call("SELECT * FROM edomiLive.visu");
	if ($n=sql_result($ss1)) {
		//SID falsch => Login
		do {
			if ($visuId==$n['id']) {
				$html.="<option value='".$n['id']."' selected>".ajaxEncode($n['name'])." (".$n['id'].")</option>";
			} else {
				$html.="<option value='".$n['id']."'>".ajaxEncode($n['name'])." (".$n['id'].")</option>";
			}
		} while ($n=sql_result($ss1));
?>
		jsLogin("<?echo $visuId;?>","<?echo $html;?>");
<?
	} else {
		//SID falsch und VisuId bzw. DB existiert nicht => Neustart
?>
		serverNotReady("<?echo $visuId;?>");
<?
	}
}


function cmd($cmd,$visuCmd) {
	global $appId,$visuId,$pageId,$data,$dataArr,$phpdata,$phpdataArr,$clientDatetime,$sid,$vid;

	if ($cmd=='login') {
		$sid=loginVisu($phpdataArr[0],$phpdataArr[1],$phpdataArr[2]);
		if ($sid!==false) {

			if ($phpdataArr[3]=='0') {
				//Standard-Login
?>
				sid="<?echo $sid;?>";
				document.getElementById("login").style.display="none";
				document.getElementById("login").innerHTML="";
				initVisu("<?echo $phpdataArr[0];?>");
<?
			} else {
				//POST-Login mit Reload (damit meta-viewport garantiert akzeptiert wird)
?>
				document.getElementById("loginvisuid").value="<?echo $phpdataArr[0];?>";
				document.getElementById("loginsid").value="<?echo $sid;?>";
				document.getElementById("loginform-post").submit();
<?
			}
			
		} else {
?>
			document.getElementById("login-loginform-fd1").value="";
			document.getElementById("login-loginform-fd2").value="";
			document.getElementById("login-loginform-fd1").focus();
			shakeObj("loginform");
<?
		}
	}
	
	if ($cmd=='initVisu') {
		if ($vid!=global_version) {
?>
			self.location.reload();
<?
			return;
		}
?>
		document.getElementById("windowContainer").style.display="none";
<?
		if (getEdomiStatus()==3) {

			//Visu initialisieren
			$ss1=sql_call("SELECT * FROM edomiLive.visu WHERE (id=".$visuId.")");
			if ($visu=sql_result($ss1)) {

				//Bilder ggf. preloaden
?>
				preload_imagesFile=new Array();
				preload_imagesObj=new Array();
<?

				if (global_visuPreload) {
					$ss2=sql_call("SELECT DISTINCT(bgimgfn) AS imgfn FROM edomiLive.visuPage WHERE (visuid=".$visuId." AND bgimgfn IS NOT NULL AND bgimgfn<>'') UNION SELECT DISTINCT(img) FROM edomiLive.visuElementStyle WHERE (visuid=".$visuId." AND img IS NOT NULL AND img<>'')");
					while ($n=sql_result($ss2)) {
?>
						preload_imagesFile.push("../data/liveproject/visu/img/<?ajaxEcho($n['imgfn']);?>");
<?
					}
				}
				
				//Indikatorfarben holen
				$cssIndiColor1=sql_getValue('edomiLive.visuFGcol','color',"id='".$visu['indicolor']."'");
				if (isEmpty($cssIndiColor1)) {$cssIndiColor1='#80e000';}	//Default: hellgrün
				$cssIndiColor2=sql_getValue('edomiLive.visuFGcol','color',"id='".$visu['indicolor2']."'");
				if (isEmpty($cssIndiColor2)) {$cssIndiColor2='inherit';}	//Default: Vordergrundfarbe des Visuelements nehmen


				//Animationen (CSS) einfügen
?>
				var n="";
<?
				$ss2=sql_call("SELECT DISTINCT(b.id),b.keyframes FROM edomiLive.visuElementStyle AS a,edomiLive.visuAnim AS b WHERE (a.visuid=".$visuId." AND a.anim>0 AND a.anim=b.id)");
				while ($n=sql_result($ss2)) {
?>
					n+="@-webkit-keyframes anim-<?echo $n['id'];?> {<?echo str_replace(chr(10),' ',$n['keyframes']);?>}\n";
<?
				}
				//ShortClick: CSS-Klasse einfügen
?>
				n+=".shortClick{background:<?ajaxValue($cssIndiColor1);?> !important;}";
				document.getElementById("animations").innerHTML=n;
<?

				//Fonts einfügen
?>
				var n="";
<?
				$ss2=sql_call("SELECT * FROM edomiLive.visuFont");
				while ($n=sql_result($ss2)) {
					if ($n['fonttyp']==1) {	//Custom-Font
?>
						n+="@font-face {font-family:'font<?echo $n['id'];?>'; font-style:<?if ($n['fontstyle']==0) {echo 'normal';} else {echo 'italic';}?>; font-weight:<?if ($n['fontweight']==0) {echo 'normal';} else {echo 'bold';}?>; src:url('../../data/liveproject/visu/etc/font-<?echo $n['id'];?>.ttf?<?echo $n['fontname'];?>') format('truetype');}\n";
<?
					} else {				//System-Font
?>
						n+="@font-face {font-family:'font<?echo $n['id'];?>'; src:local('<?ajaxEcho($n['fontname']);?>');}\n";
<?
					}
				}
?>
				document.getElementById("cssFonts").innerHTML=n;
<?

				//Fenster erstellen
?>
				openWindow(<?echo $visu['xsize'];?>,<?echo $visu['ysize'];?>);
<?				
				//Viewport einstellen (iOS)
?>
				document.getElementById("meta-viewport").setAttribute('content','user-scalable=no, width=<?echo $visu['xsize'];?>');
<?
				//Visu-Daten
?>
				visu_indiColor='<?ajaxValue($cssIndiColor1);?>';
				visu_indiColorText='<?ajaxValue($cssIndiColor2);?>';

				var d=document.getElementById("windowContainer");
				visu_visuid=<?echo $visu['id'];?>;
				visu_sspageid=<?echo $visu['sspageid'];?>;
				visu_sstimeout=<?echo $visu['sstimeout'];?>;
				d.style.width="<?echo $visu['xsize'];?>px";
				d.style.height="<?echo $visu['ysize'];?>px";
				
<?
				//Fehlermeldungen deaktivieren (showWarnings)?
				if (!global_visuShowErrors) { ?> visu_showWarningErr=-1; <? }

				//Visu-Daten (Userabhängig)
				$ss2=sql_call("SELECT * FROM edomiLive.visuUser WHERE (id=".$visuCmd['targetid'].")");
				if ($n=sql_result($ss2)) {

					//Status-KO des Accounts auf VisuID setzen
					if ($n['gaid']>=1) {
						sql_call("INSERT INTO edomiLive.RAMknxRead (mode,gatyp,gaid,value) VALUES (4,0,".$n['gaid'].",'".$visu['id']."')");
					}
					
					//Visu-Daten
					if ($n['touchscroll']==1) { ?> visu_allowScrolling=true; <? } else { ?> visu_allowScrolling=false; <? } ?>
					visu_touchMode=<?echo $n['touch'];?>;
<?
					//Einstellungen ggf. aus db.visu holen
					if (isEmpty($n['refresh'])) {$n['refresh']=$visu['refresh'];}
					if (isEmpty($n['ssrefresh'])) {$n['ssrefresh']=$visu['ssrefresh'];}
					if ($n['ssrefresh']==0) {$n['ssrefresh']=$n['refresh'];}
					if (isEmpty($n['clickrefresh'])) {$n['clickrefresh']=$visu['clickrefresh'];}
					if (isEmpty($n['queuelatency'])) {$n['queuelatency']=$visu['queuelatency'];}
					if (!($n['queuelatency']>0)) {$n['queuelatency']=0;}
?>
					visu_refresh=<?echo $n['refresh'];?>;
					visu_defaultrefresh=<?echo $n['refresh'];?>;
					visu_ssrefresh=<?echo $n['ssrefresh'];?>;
					visu_clickrefresh=<?echo $n['clickrefresh'];?>;
					visu_cmdQueueLatency=<?echo $n['queuelatency'];?>;
<?
				}
				sql_close($ss2);
?>
				//Touch oder Klick? (0=Automatisch, 1=Klick, 2=Touch)
				downEvent='mousedown';
				moveEvent='mousemove';
				upEvent='mouseup';
				if (visu_touchMode==0 && ('ontouchstart' in window)) {
					downEvent='touchstart';
					moveEvent='touchmove';
					upEvent='touchend';
				} else if (visu_touchMode==1) {
					downEvent='mousedown';
					moveEvent='mousemove';
					upEvent='mouseup';
				} else if (visu_touchMode==2) {
					downEvent='touchstart';
					moveEvent='touchmove';
					upEvent='touchend';
				}

				//Scrolling auf iOS/Touchdevice ggf. verhindern
				window.removeEventListener(moveEvent,disableScrolling,false);
				if (!visu_allowScrolling) {
					window.addEventListener(moveEvent,disableScrolling,false);
				}				
<?
				//Soundausgabe ggf. aktivieren
				$tmp=sql_getCount('edomiLive.visuElement',"visuid='".$visuId."' AND controltyp=30");
				$tmp+=sql_getCount('edomiLive.logicCmdList',"(outmode=24 AND outid='".$visuId."') OR (outmode=25 AND outid='".$visuCmd['targetid']."')");
				$tmp+=sql_getCount('edomiLive.visuCmdList',"(outmode=24 AND outid='".$visuId."') OR (outmode=25 AND outid='".$visuCmd['targetid']."')");
				$tmp+=sql_getCount('edomiLive.sequenceList',"(outmode=24 AND outid='".$visuId."') OR (outmode=25 AND outid='".$visuCmd['targetid']."')");
				if ($tmp>0) {
?>
					visu_soundEnabled=1;
					visuSoundInit();
<?
				}

				//TextToSpeech ggf. aktivieren
				$tmp=sql_getCount('edomiLive.visuElement',"visuid='".$visuId."' AND controltyp=31");
				$tmp+=sql_getCount('edomiLive.logicCmdList',"(outmode=26 AND outid='".$visuId."') OR (outmode=27 AND outid='".$visuCmd['targetid']."')");
				$tmp+=sql_getCount('edomiLive.visuCmdList',"(outmode=26 AND outid='".$visuId."') OR (outmode=27 AND outid='".$visuCmd['targetid']."')");
				$tmp+=sql_getCount('edomiLive.sequenceList',"(outmode=26 AND outid='".$visuId."') OR (outmode=27 AND outid='".$visuCmd['targetid']."')");
				if ($tmp>0) {
?>
					visu_textToSpeechEnabled=1;
					visuTextToSpeechInit();
<?
				}

				//Visu-Inititalisierung, Visualarm und Sound zurücksetzen
				sql_call("UPDATE edomiLive.visuUserList SET visuinit=NULL,visupageid=NULL,visusoundid=NULL,visuspeech=NULL WHERE (id='".$visuCmd['id']."')");

				//ggf. Bilder preloaden und Visu starten
?>
				visu_startPageId="<?echo $visu['defaultpageid'];?>";
				prepareVisu();
<?
			} else {
				//VisuId bzw. DB existiert nicht
?>
				serverNotReady(<?echo $visuId;?>);
<?
			}
			
		} else {
			//EDOMI ist nicht bereit
?>
			serverNotReady(<?echo $visuId;?>);
<?
		}
	}

	if ($cmd=='initPage') {
		$ss1=sql_call("SELECT * FROM edomiLive.visuPage WHERE (id=".$pageId.")");
		if ($page=sql_result($ss1)) {

		//Status-KO2 ggf. setzen
		$tmp=sql_getValue('edomiLive.visuUser','gaid2','id='.$visuCmd['targetid']);
		if ($tmp>=1) {
			$n=$visuId.';'.$pageId.';'.$visuCmd['targetid'].';'.$visuCmd['loginip'];	//VisuID;PageID;UserID;LoginIP
			sql_call("INSERT INTO edomiLive.RAMknxRead (mode,gatyp,gaid,value) VALUES (4,0,".$tmp.",'".sql_encodeValue($n)."')");
		}
?>
			var renderPage=false;
<?
			if ($page['pagetyp']==1) {	//Popup
?>
				if (!focusExistingPopup(<?echo $pageId;?>)) {
					clearTimeout(pageTimer);
					clearTimeout(clickTimer);
					clearTimeout(errorTimer);
					renderPage=true;
	
					var parentWin=openWindow(<?echo $page['xsize'];?>,<?echo $page['ysize'];?>);
					if (<?echo $page['autoclose'];?>!=0) {
						document.getElementById(parentWin).dataset.autoclosetimer=window.setTimeout(function(){closePopup(parentWin);},<?echo $page['autoclose'];?>*1000);
					}
				}
<?
			} else {	//normale Seite/globale Inkludeseite
?>
				clearTimeout(pageTimer);
				clearTimeout(clickTimer);
				clearTimeout(errorTimer);
				renderPage=true;
	
				closeAllPopups();
				clearObject("w0-page",0);
				var parentWin="w0";
				if (document.getElementById("shortclick")) {document.getElementById("shortclick").style.display="none";}
<?
			}
	
?>
			if (renderPage) {
<?
				//===================================================================================================================================================
				//Visuelemente ggf. erzeugen (wenn es sich um ein bereits existierendes Popup handelt, wird die Seite nicht aufgebaut - zumindest nicht in JS)
				//===================================================================================================================================================
		
				//Page-Daten für DIESE Seite merken:
				//-------------------------------
?>
				var d=document.getElementById(parentWin);
				d.dataset.pageid=<?echo $page['id'];?>;
				d.dataset.pagetyp=<?echo $page['pagetyp'];?>;
<?		
				//Container der Elemente (w#-page): winId (w#) merken (wird für PopupClose gebraucht...)
?>
				document.getElementById(parentWin+"-page").dataset.winid=parentWin;
<?		
				//Offset der Seite (Popup) bezogen auf linke/obere Ecke des Browsers
				//(wird weiter unten JEDEM Element als dataset zugewiesen, um ggf. in Popups die absolute Position eines Elements zu bestimmen)
?>
				var pageXpos=document.getElementById(parentWin+"-page").offsetLeft;
				var pageYpos=document.getElementById(parentWin+"-page").offsetTop;
<?
		
				//Elemente erzeugen
				//-------------------------------

				//Inklude-Verkettung auflösen (einschließlich aktueller Seite)
				$pageIncludeIDs=array($page['id']);	//aktuelle Visuseite
				if ($page['pagetyp']==0) {

					//Inklude-Seiten:
					$tmp=$page['includeid'];	//Start-IncludeId der aktuellen Visuseite
					while (!isEmpty($tmp) && is_numeric($tmp) && $tmp>0 && !in_array($tmp,$pageIncludeIDs)) {
						array_unshift($pageIncludeIDs,$tmp);
						$ss2=sql_call("SELECT includeid FROM edomiLive.visuPage WHERE id=".$tmp);
						$tmp=0;
						if ($n=sql_result($ss2)) {
							if (!isEmpty($n['includeid']) && is_numeric($n['includeid']) && $n['includeid']>0) {
								$tmp=$n['includeid'];
							} else {
								$tmp=0;
							}
						}
						sql_close($ss2);
					}

					if ($page['globalinclude']==1) {
						//Globale Inkludeseiten:
						$ss2=sql_call("SELECT id FROM edomiLive.visuPage WHERE (visuid=".$visuId." AND pagetyp=2 AND id<>".$page['id'].") ORDER BY id DESC");
						while ($n=sql_result($ss2)) {
							array_unshift($pageIncludeIDs,$n['id']);
						}
						sql_close($ss2);
					}
				}
				$currentPageIDs=implode(',',$pageIncludeIDs);

				//Seiten-Hintergrund
				//-------------------------------
				$tmp1='';
				$tmp2='';
				$ss2=sql_call("SELECT bgimgfn,bgcolor FROM edomiLive.visuPage WHERE (id IN (".$currentPageIDs.")) ORDER BY FIELD(id,".$currentPageIDs.") DESC");
				while ($nn=sql_result($ss2)) {
					if (isEmpty($tmp1) && !isEmpty($nn['bgimgfn'])) {$tmp1="url('../data/liveproject/visu/img/".$nn['bgimgfn']."')";}
					if (isEmpty($tmp2) && !isEmpty($nn['bgcolor'])) {$tmp2=$nn['bgcolor'];}
				}
				sql_close($ss2);
				$tmp=trim(($tmp1.','.$tmp2),',');
				if (!isEmpty($tmp)) {
?>
					document.getElementById(parentWin+"-page").style.background="<?ajaxEcho($tmp);?>";
					document.getElementById(parentWin+"-page").style.backgroundSize="100% 100%";
					document.getElementById(parentWin+"-page").style.backgroundRepeat="no-repeat";
<?
				} else {
?>
					document.getElementById(parentWin+"-page").style.background="";
<?
				}

				//Seitenelemente aufbauen
				$ss2=sql_call("SELECT * FROM edomiLive.visuElement WHERE (pageid IN (".$currentPageIDs.")) ORDER BY FIELD(pageid,".$currentPageIDs.") ASC,id ASC");
				while ($item=sql_result($ss2)) {
		
					//DIV erzeugen und allgemeine Eigenschaften
?>
					var d=createNewDiv(parentWin+"-page","e-<?echo $item['id'];?>");
					d.dataset.id=<?echo $item['id'];?>;
					d.dataset.controltyp=<?echo $item['controltyp'];?>;
<?
					if ($item['controltyp']==24) {
						//Codeschloss: Länge des Codes
?>
						d.dataset.var1="<?ajaxValue(strlen($item['var1']));?>";
<?
					} else {
?>
						d.dataset.var1="<?ajaxValue($item['var1']);?>";
<?
					}
?>
					d.dataset.var2="<?ajaxValue($item['var2']);?>";
					d.dataset.var3="<?ajaxValue($item['var3']);?>";
					d.dataset.var4="<?ajaxValue($item['var4']);?>";
					d.dataset.var5="<?ajaxValue($item['var5']);?>";
					d.dataset.var6="<?ajaxValue($item['var6']);?>";
					d.dataset.var7="<?ajaxValue($item['var7']);?>";
					d.dataset.var8="<?ajaxValue($item['var8']);?>";
					d.dataset.var9="<?ajaxValue($item['var9']);?>";
					d.dataset.var10="<?ajaxValue($item['var10']);?>";
					d.dataset.gotopageid=<?echo ($item['gotopageid']+0);?>;
					d.dataset.closepopup=<?echo $item['closepopup'];?>;
					d.dataset.hascmd=<?echo $item['hascmd'];?>;
					d.dataset.pagex=pageXpos;
					d.dataset.pagey=pageYpos;
<?
					//Anklickbar?
					if ($item['gotopageid']>0 || $item['closepopup']>0 || $item['hascmd']>0) {
?>
						d.dataset.var0="1";
<?
					} else {
?>
						d.dataset.var0="0";
<?
					}
					
					//nur gaid/value zuweisen, wenn vorhanden! (sonst braucht's ja auch nicht refreshed zu werden...)
					$koValue=null;
					$koTS=null;
					$koDPT=null;
					if ($item['gaid']>0) {
						$ss3=sql_call("SELECT visuts,value,valuetyp,vmin,vmax,vstep,vlist FROM edomiLive.RAMko WHERE (id=".$item['gaid'].")");
						if ($ko=sql_result($ss3)) {
							$koValue=$ko['value'];
							$koTS=$ko['visuts'];
							$koDPT=$ko['valuetyp'];
?>
							d.dataset.ts="<?echo $koTS;?>";
							d.dataset.gaid="<?echo $item['gaid'];?>";
							d.dataset.value="<?ajaxValue($koValue);?>";
<?
						}
					}
					if ($item['gaid2']>0) {
						$ss3=sql_call("SELECT value FROM edomiLive.RAMko WHERE (id=".$item['gaid2'].")");
						if ($ko=sql_result($ss3)) {
?>
							d.dataset.gaid2="<?echo $item['gaid2'];?>";
							d.dataset.value2="<?ajaxValue($ko['value']);?>";
<?
						}
					}
							
					//Visuelemente individuell erzeugen
					if ($item['controltyp']==1) {
						//Universalelement
?>
						control1_construct(d,<?echo $item['id'];?>);
<?
					} else if ($item['controltyp']==2) {
						//Bildelement
?>
						control2_construct(d,<?echo $item['id'];?>);
<?
					} else if ($item['controltyp']==10) {
						//Tastatureingabe
?>
						control10_construct(d,<?echo $item['id'];?>,"<?ajaxValue($koValue);?>");
<?
					} else if ($item['controltyp']==11) {
						//Drehregler
?>
						control11_construct(d,<?echo $item['id'];?>);
<?
					} else if ($item['controltyp']==12) {
						//Dimmer/RGB/HSV
?>
						control12_construct(d,<?echo $item['id'];?>);
<?
					} else if ($item['controltyp']==13) {
						//Schieberegler
?>
						control13_construct(d,<?echo $item['id'];?>);
<?
					} else if ($item['controltyp']==14) {
						//Liste/Tabelle
?>
						control14_construct(d,<?echo $item['id'];?>);
<?
					} else if ($item['controltyp']==15) {
						//Farbauswahl (Bild)
?>
						control15_construct(d,<?echo $item['id'];?>);
<?
					} else if ($item['controltyp']==16) {
						//Notizen
?>
						control16_construct(d,<?echo $item['id'];?>);
<?
					} else if ($item['controltyp']==17) {
						//Analoguhr
?>
						control17_construct(d,<?echo $item['id'];?>);
<?
					} else if ($item['controltyp']==20) {
						//Kamerabild
?>
						control20_construct(d,<?echo $item['id'];?>);
<?
					} else if ($item['controltyp']==21) {
						//Diagramm
?>
						control21_construct(d,<?echo $item['id'];?>);
<?
					} else if ($item['controltyp']==22) {
						//Zeitschaltuhr
?>
						control22_construct(d,<?echo $item['id'];?>,"<?echo $item['gaid'];?>","<?echo ajaxValueHTML(sql_getValue('edomiLive.timer','name','id='.$item['var1']));?>");
<?
					} else if ($item['controltyp']==23) {
						//Anwesenheitssimulation
?>
						control23_construct(d,<?echo $item['id'];?>,"<?echo $item['gaid'];?>","<?echo ajaxValueHTML(sql_getValue('edomiLive.aws','name','id='.$item['var1']));?>");
<?
					} else if ($item['controltyp']==24) {
						//Codeschloss
?>
						control24_construct(d,<?echo $item['id'];?>);
<?
					} else if ($item['controltyp']==25) {
						//Meldungsarchiv
?>
						control25_construct(d,<?echo $item['id'];?>,"<?echo ajaxValueHTML(sql_getValue('edomiLive.archivMsg','name','id='.$item['var1']));?>");
<?
					} else if ($item['controltyp']==26) {
						//Datenarchiv
?>
						control26_construct(d,<?echo $item['id'];?>,"<?echo ajaxValueHTML(sql_getValue('edomiLive.archivKo','name','id='.$item['var1']));?>");
<?
					} else if ($item['controltyp']==27) {
						//Rundinstrument
?>
						control27_construct(d,<?echo $item['id'];?>);
<?
					} else if ($item['controltyp']==28) {
						//Anrufarchiv
?>
						control28_construct(d,<?echo $item['id'];?>,"<?echo ajaxValueHTML(sql_getValue('edomiLive.archivPhone','name','id='.$item['var1']));?>");
<?
					} else if ($item['controltyp']==29) {
						//Bild-/Webseiten-URL
?>
						control29_construct(d,<?echo $item['id'];?>);
<?
					} else if ($item['controltyp']==30) {						
						//Ton-URL
?>
						control30_construct(d,<?echo $item['id'];?>);
<?
					} else if ($item['controltyp']==31) {						
						//Sprachausgabe
?>
						control31_construct(d,<?echo $item['id'];?>);
<?
					} else if ($item['controltyp']==32) {
						//Terminschaltuhr
?>
						control32_construct(d,<?echo $item['id'];?>,"<?echo $item['gaid'];?>","<?echo ajaxValueHTML(sql_getValue('edomiLive.agenda','name','id='.$item['var1']));?>");
<?
					}

					//Design zuweisen
					setElementDesign($item['id'],$koValue,$koDPT,$koTS);
				}
				//===================================================================================================================================================
				//Ende der Erzeugung der Visuelemente
				//===================================================================================================================================================
?>
			} //JS: if (renderPage)...
<?
			//Warnungen anzeigen
			showWarnings();

			//Refresh-Timer setzen (erstmalig)
?>
			clearTimeout(pageTimer);
			pageTimer=window.setTimeout("refreshPage();",visu_refresh*1000);
<?	
		} else {
			//Seite existiert nicht
?>
			serverNotReady(<?echo $visuId;?>);
<?
		}
	}


	if ($cmd=='refreshPage') { 	//Visu-Seite refreshen
		if ($vid!=global_version) {
?>
			self.location.reload();
<?
			return;
		}
		if (getEdomiStatus()==3) {
			$refresh=true;

			//Warnungen anzeigen
			showWarnings();

			//Soundanforderung?	
			if (!isEmpty($visuCmd['visusoundid'])) {
				if ($visuCmd['visusoundid']>0 && file_exists(MAIN_PATH.'/www/data/liveproject/visu/etc/snd-'.$visuCmd['visusoundid'].'.mp3')) {
?>
					visuSoundPlay("<?echo $visuCmd['visusoundid'];?>","",false);
<?
				} else if ($visuCmd['visusoundid']==0) {
?>
					visuSoundStop();
<?
				}
				//Soundanforderung löschen
				sql_call("UPDATE edomiLive.visuUserList SET visusoundid=NULL WHERE (id='".$visuCmd['id']."')");
			}

			//Sprachausgabe-Anforderung?	
			if (!isEmpty($visuCmd['visuspeech'])) {
				//Parameter parsen:
				$para=array('','','');
				$msg=$visuCmd['visuspeech'];
				$tmp=explode('***',$msg);
				if (count($tmp)>1) {
					$para=explode('/',$tmp[0]);
					$msg=$tmp[1];
				}
?>
				visuTextToSpeechPlay("","<?ajaxValue($para[0]);?>","<?ajaxValue($para[1]);?>","<?ajaxValue($para[2]);?>","<?ajaxValue($msg);?>");
<?
				//Sprachausgabe-Anforderung löschen
				sql_call("UPDATE edomiLive.visuUserList SET visuspeech=NULL WHERE (id='".$visuCmd['id']."')");
			}
			
			//Visu-Inititalisierung? (nach Projektaktivierung)
			if ($visuCmd['visuinit']==1) {
?>
				control1_LongClickCancel();
				serverNotReady(<?echo $visuId;?>);
<?
				//Visuinit löschen
				sql_call("UPDATE edomiLive.visuUserList SET visuinit=NULL WHERE (id='".$visuCmd['id']."')");
				$refresh=false;
				
			//VisuAlarm?
			} else if (!isEmpty($visuCmd['visupageid']) && $visuCmd['visupageid']>=0) {
				if ($visuCmd['visupageid']>0) {
?>
					control1_LongClickCancel();
					initPage(<?echo $visuCmd['visupageid'];?>,true);
<?
					$refresh=false;
				} else {
?>
					control1_LongClickCancel();
					closeAllPopups();
<?
				}
				//Visualarm löschen
				sql_call("UPDATE edomiLive.visuUserList SET visupageid=NULL WHERE (id='".$visuCmd['id']."')");
			}
			
			//kein (erfolgreicher) Visualarm => normaler Refresh
			if ($refresh) {
				for ($t=0;$t<count($dataArr);$t++) {
					$n=explode(AJAX_SEPARATOR2,$dataArr[$t]);
					$ss1=sql_call("SELECT visuts,value,valuetyp FROM edomiLive.RAMko WHERE (id=".$n[1].")");
					if ($ko=sql_result($ss1)) {
						if ((string)$ko['visuts']!==(string)$n[2]) {
							setElementDesign($n[0],$ko['value'],$ko['valuetyp'],$ko['visuts'],false);
						}
					}
				}	
				//Refresh-Timer setzen
?>
				clearTimeout(pageTimer);
				pageTimer=window.setTimeout("refreshPage();",visu_refresh*1000);
<?
			}
		} else {
			//EDOMI ist nicht bereit
?>
			serverNotReady(<?echo $visuId;?>);
<?
		}
	}
	
}


sql_disconnect();


//---------------------------------------------------------------------

function showWarnings() {
	global $clientDatetime;
	$ss1=sql_call("SELECT 1,GROUP_CONCAT(value ORDER BY id ASC SEPARATOR ',') AS anz1 FROM edomiLive.RAMko WHERE (id>=7 AND id<=10) GROUP BY 1");
	if ($n=sql_result($ss1)) {
?>
		showWarnings(<?echo $n['anz1'];?>,<?echo checkClientServerDateTime($clientDatetime);?>);
<?
	}
}

function setElementDesign($elementId,$koValue,$koDPT,$koTS,$firstinit=true) {
	global $global_dptData;

	$item=false;

	if (isEmpty($koDPT)) {
	
		//kein KO vorhanden => Defaultdesign
		$ss1=sql_call("SELECT * FROM edomiLive.visuElementStyle WHERE (targetid=".$elementId." AND styletyp=0)");
		if ($item=sql_result($ss1)) {$css=$item['css'];}
		$dynStyle=false;

	} else {

		if ($global_dptData[$koDPT][2]==3 || $global_dptData[$koDPT][2]==4) {
			//Stringvergleich
			$ss1=sql_call("SELECT * FROM edomiLive.visuElementStyle WHERE (targetid=".$elementId." AND styletyp=1 AND '".sql_encodeValue($koValue)."'>=fromvalue AND '".sql_encodeValue($koValue)."'<=tovalue)");
		} else if ($global_dptData[$koDPT][2]==0) { 							
			//Variant: String- oder nummerischer Vergleich
			if (is_numeric($koValue)) {
				$ss1=sql_call("SELECT * FROM edomiLive.visuElementStyle WHERE (targetid=".$elementId." AND styletyp=1 AND ".sql_encodeValue($koValue).">=fromvalue AND ".sql_encodeValue($koValue)."<=tovalue)");
			} else {
				$ss1=sql_call("SELECT * FROM edomiLive.visuElementStyle WHERE (targetid=".$elementId." AND styletyp=1 AND '".sql_encodeValue($koValue)."'>=fromvalue AND '".sql_encodeValue($koValue)."'<=tovalue)");
			}
		} else {
			//Nummerischer Vergleich
			$ss1=sql_call("SELECT * FROM edomiLive.visuElementStyle WHERE (targetid=".$elementId." AND styletyp=1 AND ".sql_encodeValue($koValue).">=fromvalue AND ".sql_encodeValue($koValue)."<=tovalue)");
		}	

		if ($item=sql_result($ss1)) {
			//dynamisches Design
			$css=$item['css'];
			$dynStyle=true;
		} else {
			//Fallback zum Defaultdesign (keinen passendes dynamisches Design gefunden)
			$ss1=sql_call("SELECT * FROM edomiLive.visuElementStyle WHERE (targetid=".$elementId." AND styletyp=0)");
			if ($item=sql_result($ss1)) {$css=$item['css'];}
			$dynStyle=false;
		}
		
	}


	if ($item) { //wird immer true sein, da immer zumindest ein Defaultdesign existieren wird
?>
		var d=document.getElementById("e-<?echo $elementId;?>");
		if (d) {
			d.dataset.ts="<?echo $koTS;?>";
			d.dataset.value="<?ajaxValue($koValue);?>";
<?
			//Animation mit diesem Trick neustarten 
			//(falls es sich um die gleiche Animation wie zuvor handelt, wird die Animation ohne diesen Trick nicht neugestartet!)
			if ($item['anim']>0) {
?>
				d.style.cssText="-webkit-animation:none;";
				d.offsetWidth;
<?
			}

			if ($firstinit || $item['initonly']==0 || $dynStyle) {
?>
				d.style.cssText=pS("<?ajaxEcho($css);?>","<?ajaxValue($koValue);?>");
				if (parseFloat(d.style.opacity)==0) {
					d.style.pointerEvents="none";
				}
<?
			}

			if ($item['controltyp']==1) {
				//Universalelement: Inhalt-Refresh
				//-------------------------------------------------
?>
				document.getElementById("e-<?echo $elementId;?>-text").innerHTML=pS("<?echo ajaxValueHTML($item['text']);?>","<?ajaxValue($koValue);?>");
<?
			} else if ($item['controltyp']==2) {
				//Bildelement: Inhalt-Refresh
				//-------------------------------------------------
?>
				document.getElementById("e-<?echo $elementId;?>-text").innerHTML=pS("<?echo ajaxValueHTML($item['text']);?>","<?ajaxValue($koValue);?>");
<?
			} else if ($item['controltyp']==10) {
				//Tastatureingabe: Inhalt-Refresh
				//-------------------------------------------------
				if (preg_match('/\{(.*?)\}/s',$item['text'].'{#}',$tmp)>0) {$caption=$tmp[0];} else {$caption=$item['text'];}
?>
				d.dataset.blocked=0;
				d.dataset.caption="<?echo ajaxValueHTML($caption);?>";
				document.getElementById("e-<?echo $elementId;?>-text").innerHTML=pS("<?echo ajaxValueHTML($item['text']);?>","<?ajaxValue($koValue);?>");
<?
			} else if ($item['controltyp']==11) {
				//Drehregler: Inhalt-Refresh
				//-------------------------------------------------
				if (preg_match('/\{(.*?)\}/s',$item['text'].'{#}',$tmp)>0) {$caption=$tmp[0];} else {$caption=$item['text'];}
?>
				d.dataset.blocked=0;
				d.dataset.caption="<?echo ajaxValueHTML($caption);?>";
				document.getElementById("e-<?echo $elementId;?>-text").innerHTML=pS("<?echo ajaxValueHTML($item['text']);?>","<?ajaxValue($koValue);?>");
				control11_Init(<?echo $elementId;?>,"<?ajaxValue($koValue);?>");
<?
			} else if ($item['controltyp']==12) {
				//Dimmer/HSV/RGB: Inhalt-Refresh
				//-------------------------------------------------
?>
				d.dataset.blocked=0;
				document.getElementById("e-<?echo $elementId;?>-text").innerHTML=pS("<?echo ajaxValueHTML($item['text']);?>","<?ajaxValue($koValue);?>");
				control12_Init(<?echo $elementId;?>,"<?ajaxValue($koValue);?>");
<?
			} else if ($item['controltyp']==13) {
				//Schieberegler: Inhalt-Refresh
				//-------------------------------------------------
				if (preg_match('/\{(.*?)\}/s',$item['text'].'{#}',$tmp)>0) {$caption=$tmp[0];} else {$caption=$item['text'];}
?>
				d.dataset.blocked=0;
				d.dataset.caption="<?echo ajaxValueHTML($caption);?>";
				document.getElementById("e-<?echo $elementId;?>-text").innerHTML=pS("<?echo ajaxValueHTML($item['text']);?>","<?ajaxValue($koValue);?>");
				control13_Init(<?echo $elementId;?>,"<?ajaxValue($koValue);?>");
<?
			} else if ($item['controltyp']==14) {
				//Liste/Tabelle: Inhalt-Refresh
				//-------------------------------------------------
?>
				control14_Refresh(<?echo $elementId;?>,pS("<?echo ajaxValueHTML($item['text']);?>","<?ajaxValue($koValue);?>"));
<?
			} else if ($item['controltyp']==15) {
				//Farbauswahl (Bild): Inhalt-Refresh
				//-------------------------------------------------
?>
				document.getElementById("e-<?echo $elementId;?>-text").innerHTML=pS("<?echo ajaxValueHTML($item['text']);?>","<?ajaxValue($koValue);?>");
				control15_Init(<?echo $elementId;?>,"<?ajaxValue($item['img']);?>");
<?
			} else if ($item['controltyp']==16) {
				//Notizen: Inhalt-Refresh
				//-------------------------------------------------
?>
				document.getElementById("e-<?echo $elementId;?>-infotext").innerHTML=pS("<?echo ajaxValueHTML($item['text']);?>","<?ajaxValue($koValue);?>");
				control16_Refresh(<?echo $elementId;?>);
<?
			} else if ($item['controltyp']==17) {
				//Analoguhr: Inhalt-Refresh
				//-------------------------------------------------
?>
				document.getElementById("e-<?echo $elementId;?>-text").innerHTML=pS("<?echo ajaxValueHTML($item['text']);?>","<?ajaxValue($koValue);?>");
				control17_Draw("<?echo $elementId;?>","<?ajaxValue($koValue);?>");
<?
			} else if ($item['controltyp']==20) {
				//Kamera-Archiv: Inhalt-Refresh (nur wenn das Archiv geöffnet ist - nicht bei Livebild)
				//-------------------------------------------------
?>
				if (document.getElementById("e-<?echo $elementId;?>-imglive").style.display=="none") {
					control20_ArchivOpen(<?echo $elementId;?>); 
				}
<?
			} else if ($item['controltyp']==21) {
				//Diagramm: Inhalt-Refresh (Immer! Es könnte ja ein DateFrom/DateTo-Wert angegeben sein)
				//-------------------------------------------------
?>
				control21_Refresh(<?echo $elementId;?>,pS("<?echo ajaxValueHTML($item['text']);?>","<?ajaxValue($koValue);?>"),"<?ajaxValue($koValue);?>"); 
<?
			} else if ($item['controltyp']==22) {
				//Zeitschaltuhr: Status-Update (Inhalt kann nur manuell aktualisiert werden)
				//-------------------------------------------------
?>
				control22_Switch("<?echo $elementId;?>","<?ajaxValue($koValue);?>");
<?
			} else if ($item['controltyp']==23) {
				//AWS: Status-Update und Inhalt-Refresh
				//-------------------------------------------------
?>
				control23_Switch("<?echo $elementId;?>","<?ajaxValue($koValue);?>");
				control23_ShowInfo(<?echo $elementId;?>);
<?
			} else if ($item['controltyp']==24) {
				//Codeschloss: nichts
				//-------------------------------------------------

			} else if ($item['controltyp']==25) {
				//Meldungs-Archiv: Inhalt-Refresh
				//-------------------------------------------------
?>
				control25_ShowInfo(<?echo $elementId;?>,0);
<?
			} else if ($item['controltyp']==26) {
				//KO-Archiv: Inhalt-Refresh
				//-------------------------------------------------
?>
				control26_ShowInfo(<?echo $elementId;?>,0);
<?
			} else if ($item['controltyp']==27) {
				//Rundinstrument: Inhalt-Refresh
				//-------------------------------------------------
?>
				document.getElementById("e-<?echo $elementId;?>-text").innerHTML=pS("<?echo ajaxValueHTML($item['text']);?>","<?ajaxValue($koValue);?>");
				control27_Draw("<?echo $elementId;?>","<?ajaxValue($koValue);?>");
<?
			} else if ($item['controltyp']==28) {
				//Anrufliste: Inhalt-Refresh
				//-------------------------------------------------
?>
				control28_ShowInfo(<?echo $elementId;?>,0);
<?
			} else if ($item['controltyp']==29) {
				//Webseite/Bild-URL: Inhalt-Refresh
				//-------------------------------------------------
?>
				control29_Refresh(<?echo $elementId;?>,pS("<?echo ajaxValueHTML($item['text']);?>","<?ajaxValue($koValue);?>")); 
<?
			} else if ($item['controltyp']==30) {
				//Ton-URL: Inhalt-Refresh
				//-------------------------------------------------
?>
				control30_Refresh(<?echo $elementId;?>,pS("<?echo ajaxValueHTML($item['text']);?>","<?ajaxValue($koValue);?>")); 
<?
			} else if ($item['controltyp']==31) {
				//Sprachausgabe: Inhalt-Refresh
				//-------------------------------------------------
?>
				control31_Refresh(<?echo $elementId;?>,pS("<?echo ajaxValueHTML($item['text']);?>","<?ajaxValue($koValue);?>")); 
<?
			} else if ($item['controltyp']==32) {
				//Terminschaltuhr: Status-Update (Inhalt kann nur manuell aktualisiert werden)
				//-------------------------------------------------
?>
				control32_Switch("<?echo $elementId;?>","<?ajaxValue($koValue);?>");
<?
			}
?>
		}
<?
	}
}

?>