/* 
 * EDOMI beta (Version 1.50) - Intelligente Steuerung und Visualisierung KNX-basierter Elektro-Installationen.
 * @link http://www.edomi.de 
 * @author Dr. Christian Gärtner <dr.christian.gaertner@googlemail.com> 
 * @copyright 2015,2016,2017 Dr. Christian Gärtner 
 * @license Freeware 
 *
 *     This file and all other files are part of EDOMI.
 *
 *     EDOMI is distributed in the hope that it will be useful,
 *     but WITHOUT ANY WARRANTY; without even the implied warranty of
 *     MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 *
 *     Diese und alle anderen Dateien sind Teil von EDOMI.
 *
 *     EDOMI wird in der Hoffnung, dass es nützlich sein wird, aber
 *     OHNE JEDE GEWÄHRLEISTUNG, bereitgestellt; sogar ohne die implizite
 *     Gewährleistung der MARKTFÄHIGKEIT oder EIGNUNG FÜR EINEN BESTIMMTEN ZWECK.
*/ 
//Controltyp 10 (Tastatureingabe)
//----------------------------

function control10_construct(obj,id,koValue) {
	var n="<table cellpadding='0' cellspacing='0' border='0' style='left:0; top:0; width:100%; height:100%; pointer-events:none;'>";
		n+="<tr id='e-"+id+"-mode1'><td><span id='e-"+id+"-text'></span></td></tr>";
		n+="<tr id='e-"+id+"-mode2' style='display:none;'><td><input id='e-"+id+"-edit' type='"+((obj.dataset.var1==0)?"text":"password")+"' value='' onBlur='control10_Cancel(\""+id+"\");' on"+downEvent+"='clickCancel();' onkeydown='if (event.keyCode==13){control10_Send(\""+id+"\");}' class='input' style='left:0; top:0; background:"+visu_indiColor+"; color:"+visu_indiColorText+";'></td></tr>";
	n+="</table>";
	obj.innerHTML=n;

	document.getElementById("e-"+id+"-edit").value=koValue;

	obj.addEventListener(downEvent,function(){if (!checkClick()){return;} control10_Start(id);},false);
}

function control10_Start(elementId) {
	var d=document.getElementById("e-"+elementId);
	if (d.dataset.blocked==1) {return;}
	if (d) {
		document.getElementById("e-"+elementId+"-mode1").style.display="none";
		document.getElementById("e-"+elementId+"-mode2").style.display="table-row";
		if (d.dataset.var2==1) {
			window.setTimeout(function(){if (document.getElementById("e-"+elementId+"-edit")) {document.getElementById("e-"+elementId+"-edit").focus(); document.getElementById("e-"+elementId+"-edit").select();}},250); //Focus+Select brauchen Verzögerung
		} else {
			window.setTimeout(function(){if (document.getElementById("e-"+elementId+"-edit")) {document.getElementById("e-"+elementId+"-edit").focus();}},250); //Focus braucht Verzögerung
		}
		document.getElementById("e-"+elementId+"-edit").value=document.getElementById("e-"+elementId).dataset.value //wichtig, falls es mehrere Elemente dieser Art gibt, die auf das gleiche KO zeigen...
	}
}

function control10_Send(elementId) {
	var d=document.getElementById("e-"+elementId);
	if (d) {

		if (!isNaN(parseFloat(d.dataset.var5)) && !isNaN(parseFloat(d.dataset.var6))) {
			//Zahl
			var vmin=parseFloat(d.dataset.var5);
			var vmax=parseFloat(d.dataset.var6);
			var vstep=parseFloat(d.dataset.var7); if (isNaN(vstep)) {vstep=1;}
			var vlist=parseInt(d.dataset.var8); if (isNaN(vlist)) {vlist=0;}
			var tmp=parseFloat(document.getElementById("e-"+elementId+"-edit").value);
			tmp=parseInt(tmp/vstep)*vstep;
			if (tmp<vmin && !isNaN(vmin)) {tmp=vmin;}
			if (tmp>vmax && !isNaN(vmax)) {tmp=vmax;}
			newValue=tmp.toFixed(vlist);
		} else {
			//String
			var newValue=document.getElementById("e-"+elementId+"-edit").value;
		}
	
		var setKoMode=d.dataset.var4;
		var setKoChanged=false;
		if (d.dataset.value+"x"!==newValue+"x") {setKoChanged=true;}
		if ((setKoMode==0) || (setKoMode==1 && setKoChanged) || (setKoMode==2) || (setKoMode==3 && setKoChanged)) {
			if ((setKoMode==2) || (setKoMode==3 && setKoChanged)) {
				d.dataset.blocked=0;
			} else {
				d.dataset.blocked=1;
				if (d.dataset.var1==1) {
					var tmp="&bull;";
					document.getElementById("e-"+elementId+"-text").innerHTML="<div class='sendValueAnim2'><button class='elementContent'><span style='background:"+visu_indiColor+"; color:"+visu_indiColorText+"; padding:1px; border-radius:3px;'>"+tmp.repeat(document.getElementById("e-"+elementId+"-edit").value.length)+"</span></button></div>";
				} else {
					document.getElementById("e-"+elementId+"-text").innerHTML="<div class='sendValueAnim2'><button class='elementContent'><span style='background:"+visu_indiColor+"; color:"+visu_indiColorText+"; padding:1px; border-radius:3px;'>"+pS(d.dataset.caption,document.getElementById("e-"+elementId+"-edit").value)+"</span></button></div>";
				}
			}
			setKoValue(d.dataset.gaid2,stringCleanup(newValue));
		}
	
		document.getElementById("e-"+elementId+"-mode1").style.display="table-row";
		document.getElementById("e-"+elementId+"-mode2").style.display="none";
		document.activeElement.blur(); //iOS: blendet die Tastatur aus
	}
}

function control10_Cancel(elementId) {
	var d=document.getElementById("e-"+elementId);
	if (d) {
		document.getElementById("e-"+elementId+"-mode1").style.display="table-row";
		document.getElementById("e-"+elementId+"-mode2").style.display="none";
	}
}
