/* 
 * EDOMI beta (Version 1.50) - Intelligente Steuerung und Visualisierung KNX-basierter Elektro-Installationen.
 * @link http://www.edomi.de 
 * @author Dr. Christian Gärtner <dr.christian.gaertner@googlemail.com> 
 * @copyright 2015,2016,2017 Dr. Christian Gärtner 
 * @license Freeware 
 *
 *     This file and all other files are part of EDOMI.
 *
 *     EDOMI is distributed in the hope that it will be useful,
 *     but WITHOUT ANY WARRANTY; without even the implied warranty of
 *     MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 *
 *     Diese und alle anderen Dateien sind Teil von EDOMI.
 *
 *     EDOMI wird in der Hoffnung, dass es nützlich sein wird, aber
 *     OHNE JEDE GEWÄHRLEISTUNG, bereitgestellt; sogar ohne die implizite
 *     Gewährleistung der MARKTFÄHIGKEIT oder EIGNUNG FÜR EINEN BESTIMMTEN ZWECK.
*/ 
//Controltyp 16 (Notizen)
//----------------------------

function control16_construct(obj,id) {

	control16_maxResXY=10000;		//Skizzen: max. Auflösung in Pixel (in X- und Y-Richtung)
									//Achtung: Wenn dieser Wert verändert wird, werden vorhandene(!) Skizzen u.U. nicht korrekt dargestellt!

	var mheight=(obj.dataset.var10!='')?obj.dataset.var10:40;

	if (obj.dataset.var1==0) {
		//Text
		var n="<table cellpadding='0' cellspacing='0' border='0' style='position:absolute; left:0; top:0; width:100%; height:100%;'>";
			n+="<tr id='e-"+id+"-menu1' style='height:"+mheight+"px;'>";
				n+="<td width='20%' align='center' id='e-"+id+"-last'>&larr;</td>";
				n+="<td width='60%' align='center' id='e-"+id+"-info'><div id='e-"+id+"-infotext' style='max-height:"+mheight+"px; overflow:hidden;'></div></td>";
				n+="<td width='20%' align='center' id='e-"+id+"-next'>&rarr;</td>";
			n+="</tr>";
			n+="<tr id='e-"+id+"-menu2' style='height:"+mheight+"px; display:none;'>";
				n+="<td width='33%' align='center' id='e-"+id+"-delete'>Löschen</td>";
				n+="<td width='33%' align='center' id='e-"+id+"-cancel'>Abbrechen</td>";
				n+="<td width='33%' align='center' id='e-"+id+"-save'>Speichern</td>";
			n+="</tr>";
			n+="<tr><td colspan='3' align='left' style='padding:5px; border-top:1px solid;'>";
				n+="<div style='position:relative; height:100%;'>";
					n+="<div id='e-"+id+"-text' style='position:absolute; top:0; left:0; right:0; bottom:0; overflow-x:hidden; overflow-y:auto; word-wrap:break-word;'></div>";
					n+="<textarea id='e-"+id+"-textEdit' wrap='off' style='display:none; width:100%; height:100%; word-wrap:break-word; font-family:inherit; font-size:inherit; resize:none; margin:0; padding:0; color:currentColor; background:transparent; border:none; outline:none; tab-size:4; box-sizing:border-box; -webkit-appearance:none;'></textarea>";
				n+="</div>";
			n+="</td></tr>";
		n+="</table>";
		obj.innerHTML=n;

		document.getElementById("e-"+id+"-last").addEventListener(downEvent,function(){if (!checkClick()){return;} showShortClickItem(this); scrollUp("e-"+id+"-text");},false);
		document.getElementById("e-"+id+"-info").addEventListener(downEvent,function(){if (!checkClick()){return;} showShortClickItem(this); scrollToTop("e-"+id+"-text");},false);
		document.getElementById("e-"+id+"-next").addEventListener(downEvent,function(){if (!checkClick()){return;} showShortClickItem(this); scrollDown("e-"+id+"-text");},false);
		document.getElementById("e-"+id+"-text").addEventListener(downEvent,function(){if (!checkClick()){return;} control16_Edit(id,true);},false);
		document.getElementById("e-"+id+"-delete").addEventListener(downEvent,function(){if (!checkClick()){return;} showShortClickItem(this); control16_Clear(id);},false);

	} else if (obj.dataset.var1==1) {
		//Skizze
		var n="<table cellpadding='0' cellspacing='0' border='0' style='position:absolute; left:0; top:0; width:100%; height:100%;'>";
			n+="<tr id='e-"+id+"-menu1' style='height:"+mheight+"px;'>";
				n+="<td colspan='3' align='center'><div id='e-"+id+"-infotext' style='max-height:"+mheight+"px; overflow:hidden;'></div></td>";
			n+="</tr>";
			n+="<tr id='e-"+id+"-menu2' style='height:"+mheight+"px; display:none;'>";
				n+="<td width='33%' align='center' id='e-"+id+"-delete'>Undo/Löschen</td>";
				n+="<td width='33%' align='center' id='e-"+id+"-cancel'>Abbrechen</td>";
				n+="<td width='33%' align='center' id='e-"+id+"-save'>Speichern</td>";
			n+="</tr>";
			n+="<tr><td colspan='3' style='border-top:1px solid;'>";
				n+="<canvas id='e-"+id+"-canvas' style='width:100%; height:100%;'></canvas>";
				n+="<canvas id='e-"+id+"-canvasEdit' style='display:none; cursor:crosshair; width:100%; height:100%;'></canvas>";
			n+="</td></tr>";
		n+="</table>";
		obj.innerHTML=n;

		document.getElementById("e-"+id+"-canvas").addEventListener(downEvent,function(){if (!checkClick()){return;} control16_Edit(id,true);},false);
		document.getElementById("e-"+id+"-canvasEdit").addEventListener(downEvent,function(){if (!checkClick()){return;} control16_DrawBegin(id);},false);

		document.getElementById("e-"+id+"-delete").addEventListener(downEvent,function(){if (!checkClick()){return;} control16_DeleteStart(id);},false);
		document.getElementById("e-"+id+"-delete").addEventListener(upEvent,function(){control16_DeleteEnd(id);},false);

	}
	document.getElementById("e-"+id+"-cancel").addEventListener(downEvent,function(){if (!checkClick()){return;} showShortClickItem(this); control16_Edit(id,false);},false);
	document.getElementById("e-"+id+"-save").addEventListener(downEvent,function(){if (!checkClick()){return;} showShortClickItem(this); control16_Send(id);},false);
}

function control16_Refresh(elementId) {
	var d=document.getElementById("e-"+elementId);
	if (d) {
		if (d.dataset.var1==0) {
			var n=d.dataset.value.replace(/[\x0A\x0E]/g,"<br>");	//CR ersetzen (nur visuell)
			n=n.replace(/[\x09]/g,"&nbsp;&nbsp;&nbsp;&nbsp;");		//TAB ersetzen (nur visuell)
			document.getElementById("e-"+elementId+"-text").innerHTML=n;
		} else if (d.dataset.var1==1) {
			control16_DrawNote(elementId,document.getElementById("e-"+elementId+"-canvas"),d.dataset.value,false,false);
		}	
	}
}

function control16_Edit(elementId,mode) {
	var d=document.getElementById("e-"+elementId);
	if (d) {
		if (mode) {
			//Öffnen
			if (d.dataset.var1==0) {
				document.getElementById("e-"+elementId+"-text").style.display="none";
				document.getElementById("e-"+elementId+"-textEdit").style.display="block";
				window.setTimeout(function(){if (document.getElementById("e-"+elementId+"-textEdit")) {document.getElementById("e-"+elementId+"-textEdit").focus();}},250);
				showShortClickItem(d);
				document.getElementById("e-"+elementId+"-textEdit").value=d.dataset.value;	
			} else if (d.dataset.var1==1) {
				document.getElementById("e-"+elementId+"-canvas").style.display="none";
				document.getElementById("e-"+elementId+"-canvasEdit").style.display="block";
				showShortClickItem(d);
				d.dataset.editvalue=d.dataset.value;
				control16_DrawNote(elementId,document.getElementById("e-"+elementId+"-canvasEdit"),d.dataset.editvalue,true,false);
			}
			document.getElementById("e-"+elementId+"-menu1").style.display="none";
			document.getElementById("e-"+elementId+"-menu2").style.display="table-row";
		} else {
			//Schliessen
			if (d.dataset.var1==0) {
				document.getElementById("e-"+elementId+"-text").style.display="block";
				document.getElementById("e-"+elementId+"-textEdit").style.display="none";	
			} else if (d.dataset.var1==1) {
				document.getElementById("e-"+elementId+"-canvas").style.display="block";
				document.getElementById("e-"+elementId+"-canvasEdit").style.display="none";
			}
			control16_Refresh(elementId);
			document.getElementById("e-"+elementId+"-menu2").style.display="none";
			document.getElementById("e-"+elementId+"-menu1").style.display="table-row";
		}
	}
}

//Undo/Delete per Short/Longclick
function control16_DeleteStart(elementId) {
	clickTimer=window.setTimeout("control16_Clear('"+elementId+"');",500);
}
function control16_DeleteEnd(elementId) {
	clearTimeout(clickTimer);
	control16_Undo(elementId);
}
function control16_Clear(elementId) {
	var d=document.getElementById("e-"+elementId);
	if (d) {
		if (d.dataset.var1==0) {
			document.getElementById("e-"+elementId+"-textEdit").value="";	
			window.setTimeout(function(){if (document.getElementById("e-"+elementId+"-textEdit")) {document.getElementById("e-"+elementId+"-textEdit").focus();}},250);
		} else if (d.dataset.var1==1) {
			showShortClickItem(document.getElementById("e-"+elementId+"-delete")); 
			d.dataset.editvalue="";
			control16_DrawNote(elementId,document.getElementById("e-"+elementId+"-canvasEdit"),d.dataset.editvalue,true,false);
		}
	}
}
function control16_Undo(elementId) {
	var d=document.getElementById("e-"+elementId);
	if (d) {
		if (d.dataset.var1==1 && d.dataset.editvalue!="") {
			showShortClickItem(document.getElementById("e-"+elementId+"-delete")); 
			var tmp=d.dataset.editvalue.split(";");
			tmp.pop();
			tmp.pop();	//leerer String nach dem letzten Separator
			if (tmp.length>0) {d.dataset.editvalue=tmp.join(";")+";";} else {d.dataset.editvalue="";}
			control16_DrawNote(elementId,document.getElementById("e-"+elementId+"-canvasEdit"),d.dataset.editvalue,true,false);
		}
	}
}

function control16_Send(elementId) {
	var d=document.getElementById("e-"+elementId);
	if (d) {
		if (d.dataset.gaid>=1) {
			if (d.dataset.var1==0) {
				setKoValue(d.dataset.gaid,document.getElementById("e-"+elementId+"-textEdit").value);
				d.dataset.value=document.getElementById("e-"+elementId+"-textEdit").value;
			} else if (d.dataset.var1==1) {
				setKoValue(d.dataset.gaid,d.dataset.editvalue);
				d.dataset.value=d.dataset.editvalue;
			}
			showShortClickItem(d); 
			control16_Edit(elementId,false);
		} else {
			shakeObj("e-"+elementId);
		}
	}
}



function control16_DrawBegin(elementId) {
	elementDragId=elementId;
	control16_Move();
	window.addEventListener(moveEvent,control16_Move,false);
	window.addEventListener(upEvent,control16_Up,false);
	if (visu_allowScrolling) {
		//Scrolling temporär verhindern
		window.addEventListener(moveEvent,disableScrolling,false);
	}
}

function control16_Move() {
	if (!event) var event=window.event;
	if (elementDragId>0) {
		var d=document.getElementById("e-"+elementDragId);
		if (d && d.dataset.controltyp==16) {

			var canvas=document.getElementById("e-"+elementDragId+"-canvasEdit");
			var tmp=canvas.getBoundingClientRect();
			var x=(getClientX(event)-tmp.left)-tmp.width/2;	//Origin: Mittelpunkt der Boundingbox
			var y=(getClientY(event)-tmp.top)-tmp.height/2;
		
			var xy=canvasGetRelativeXY(canvas,cssGetRotationAngle(d),x,y) 
			if (xy!==false) {
				var x=parseInt(xy.x/xy.cw*control16_maxResXY);
				var y=parseInt(xy.y/xy.ch*control16_maxResXY);
				var n=parseInt(x).toString(36)+","+parseInt(y).toString(36)+",";
				
				if ((d.dataset.editvalue+n).length<10000) {
					d.dataset.editvalue+=n; 
					control16_DrawNote(elementDragId,document.getElementById("e-"+elementDragId+"-canvasEdit"),d.dataset.editvalue.substring(0,d.dataset.editvalue.length-1),true,true);
				} else {
					control16_Up();
				}
			}
		}
	}
}

function control16_Up() {
	if (!event) var event=window.event;
	if (elementDragId>0) {
		var d=document.getElementById("e-"+elementDragId);
		if (d && d.dataset.controltyp==16) {

			d.dataset.editvalue=d.dataset.editvalue.substring(0,d.dataset.editvalue.length-1);
			if (d.dataset.var3>0) {
				d.dataset.editvalue=control16_OptimizePolygon(d.dataset.editvalue,(d.dataset.var3*control16_maxResXY/100)/100);
			}
			d.dataset.editvalue+=";";

			control16_DrawNote(elementDragId,document.getElementById("e-"+elementDragId+"-canvasEdit"),d.dataset.editvalue,true,false);

			elementDragId=0;
			window.removeEventListener(moveEvent,control16_Move,false);
			window.removeEventListener(upEvent,control16_Up,false);

			if (visu_allowScrolling) {
				//Scrolling wieder freigeben
				window.removeEventListener(moveEvent,disableScrolling,false);
			}
		}
	}
}

function control16_DrawNote(elementId,canvas,dataString,memory,lastonly) {
	var d=document.getElementById("e-"+elementId);
	if (d) {
		var tmp=window.getComputedStyle(canvas);
		var cWidth=tmp.width.replace("px","");
		var cHeight=tmp.height.replace("px","");

		if (lastonly) {
			if (canvas && canvas.getContext) {var c=canvas.getContext("2d");} else {c=false;}
		} else {
			var c=canvasScale(canvas,cWidth,cHeight);
		}
		
		if (c!==false) {

			c.strokeStyle=d.style.color;
			c.lineWidth=d.dataset.var2;
			c.lineCap="round";

			if (lastonly) {
				var tmp=dataString.split(";");
				polygon=[radix_StringToArray(tmp.pop(),",",36)];
			} else {
				var polygon=new Array();
				var tmp=dataString.split(";");
				for (var t=0;t<tmp.length;t++) {polygon[t]=radix_StringToArray(tmp[t],",",36);}
				c.clearRect(0,0,cWidth,cHeight);
			}

			var polysMax=polygon.length;
			for (var t=0;t<polysMax;t++) {
				var pointsMax=polygon[t].length;
				c.beginPath();
				if (pointsMax>4) {
					c.moveTo(polygon[t][0]/control16_maxResXY*cWidth,polygon[t][1]/control16_maxResXY*cHeight);
					for (var tt=2;tt<pointsMax-4;tt+=2) {c.quadraticCurveTo(polygon[t][tt]/control16_maxResXY*cWidth,polygon[t][tt+1]/control16_maxResXY*cHeight,(polygon[t][tt]/control16_maxResXY*cWidth+polygon[t][tt+2]/control16_maxResXY*cWidth)/2,(polygon[t][tt+1]/control16_maxResXY*cHeight+polygon[t][tt+3]/control16_maxResXY*cHeight)/2);}
					if (!lastonly) {c.quadraticCurveTo(polygon[t][tt]/control16_maxResXY*cWidth,polygon[t][tt+1]/control16_maxResXY*cHeight,polygon[t][tt+2]/control16_maxResXY*cWidth,polygon[t][tt+3]/control16_maxResXY*cHeight);}
				} else if (pointsMax>2) {
					c.moveTo(polygon[t][0]/control16_maxResXY*cWidth,polygon[t][1]/control16_maxResXY*cHeight);
					c.lineTo(polygon[t][2]/control16_maxResXY*cWidth+0.1,polygon[t][3]/control16_maxResXY*cHeight+0.1);
				} else if (pointsMax>0) {
					c.moveTo(polygon[t][0]/control16_maxResXY*cWidth,polygon[t][1]/control16_maxResXY*cHeight);
					c.lineTo(polygon[t][0]/control16_maxResXY*cWidth+0.1,polygon[t][1]/control16_maxResXY*cHeight+0.1);
				}
				c.lineJoin="round";
				c.stroke();
			}

			if (memory) {
				var n=100-parseFloat(dataString.length/10000*100);
				c.strokeStyle=visu_indiColor;
				c.lineWidth=1;
				c.clearRect(0,0,cWidth,1);
				c.beginPath();
				c.moveTo(0,0.5);
				c.lineTo(cWidth/100*n,0.5);
				c.stroke();
			}
			
		}
	}
}

function control16_OptimizePolygon(dataString,e) {
	//nur das aktuelle Polygon optimieren und alle Polygone zurückgeben
	var dataArray=dataString.split(";");
	var points=arrayToMatrix(radix_StringToArray(dataArray.pop(),",",36),2);

	for (var t=(points.length-1);t>0;t--) {
		if (points[0][0]==points[t][0] && points[0][1]==points[t][1]) {points.pop();} else {break;}
	}

	var r=optimize(points,0,points.length-1,e);
	r=r.concat([points[points.length-1]]);

	var newArr=new Array();
	for (var t=0;t<r.length;t++) {newArr=newArr.concat(r[t]);}

	var newDataString="";
	for (var t=0;t<dataArray.length;t++) {newDataString+=dataArray[t]+";";}
	newDataString+=radix_ArrayToString(newArr,",",36);

	return newDataString;

	function optimize(points,id0,id1,e) {
		if (id0>=(id1-1)) {return [points[id0]];}
		var px=points[id0][0];
		var py=points[id0][1];
		var dx=points[id1][0]-px;
		var dy=points[id1][1]-py;
		var nn=Math.sqrt(dx*dx+dy*dy);
		var nx=-dy/nn;
		var ny=dx/nn;
		var ii=id0;
		var max=-1;
		for (var i=id0+1;i<id1;i++) {
			var p=points[i];
			var qx=p[0]-px;
			var qy=p[1]-py;
			var d=Math.abs(qx*nx+qy*ny);
			if (d>max) {
				max=d;
				ii=i;
			}
		}
		if (max<e) {return [points[id0]];}
		var p1=optimize(points,id0,ii,e);
		var p2=optimize(points,ii,id1,e);
		return p1.concat(p2);        
	}

	function arrayToMatrix(arr,dim) {
		var r=new Array();
		var t,tt;
		for (t=0,tt=-1;t<arr.length;t++) {
			if (t%dim===0) {
				tt++;
				r[tt]=new Array();
			}
			r[tt].push(arr[t]);
		}
		return r;
	}

}
