/* 
 * EDOMI beta (Version 1.50) - Intelligente Steuerung und Visualisierung KNX-basierter Elektro-Installationen.
 * @link http://www.edomi.de 
 * @author Dr. Christian Gärtner <dr.christian.gaertner@googlemail.com> 
 * @copyright 2015,2016,2017 Dr. Christian Gärtner 
 * @license Freeware 
 *
 *     This file and all other files are part of EDOMI.
 *
 *     EDOMI is distributed in the hope that it will be useful,
 *     but WITHOUT ANY WARRANTY; without even the implied warranty of
 *     MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 *
 *     Diese und alle anderen Dateien sind Teil von EDOMI.
 *
 *     EDOMI wird in der Hoffnung, dass es nützlich sein wird, aber
 *     OHNE JEDE GEWÄHRLEISTUNG, bereitgestellt; sogar ohne die implizite
 *     Gewährleistung der MARKTFÄHIGKEIT oder EIGNUNG FÜR EINEN BESTIMMTEN ZWECK.
*/ 
//Controltyp 20 (Kamerabild)
//----------------------------

function control20_construct(obj,id) {

	var mheight=(obj.dataset.var10!='')?obj.dataset.var10:40;

	if (obj.dataset.var2==-1) {
		//Streaming (natürlich nur bei MJPEG möglich - wird hier aber nicht geprüft!)
		var n="<div id='e-"+id+"-imglive' data-stream='1' style='position:absolute; left:0; top:0; width:100%; height:100%; background:url(data:image/png;base64,iVBORw0KGgoAAAANSUhEUgAAAAUAAAAFCAYAAACNbyblAAAAAXNSR0IArs4c6QAAAChJREFUCB1jZGBgMAZiZODDhMwDsn2AeAuyIFgApAgmCBeACaIIgAQBzpEEiaAV3YQAAAAASUVORK5CYII=);'></div>";
	} else {
		//Einzelbilder
		var n="<img id='e-"+id+"-imglive' data-stream='0' draggable='false' style='position:absolute; left:0; top:0; width:100%; height:100%;' src='data:image/png;base64,iVBORw0KGgoAAAANSUhEUgAAAAEAAAABCAYAAAAfFcSJAAAADUlEQVQIHWP4//8/AwAI/AL+5gz/qwAAAABJRU5ErkJggg=='>";
	}
	n+="<img id='e-"+id+"-imgarchiv' draggable='false' style='display:none; position:absolute; left:0; top:0; width:100%; height:100%;' src='data:image/png;base64,iVBORw0KGgoAAAANSUhEUgAAAAEAAAABCAYAAAAfFcSJAAAADUlEQVQIHWP4//8/AwAI/AL+5gz/qwAAAABJRU5ErkJggg=='>";
	n+="<div id='e-"+id+"-archiv' style='display:none; position:absolute; left:0; top:0; text-align:center; width:100%;'>";
		n+="<table cellpadding='0' cellspacing='0' border='0' style='width:100%; height:100%;'>";
			n+="<tr style='height:"+mheight+"px;'>";
				n+="<td width='20%' id='e-"+id+"-last'>&larr;</td>";
				n+="<td width='60%' id='e-"+id+"-info'><div id='e-"+id+"-infotext' style='max-height:"+mheight+"px; overflow:hidden;'></div></td>";
				n+="<td width='20%' id='e-"+id+"-next'>&rarr;</td>";
			n+="</tr>";
			n+="<tr><td colspan='3' style='border-top:1px solid;'></td></tr>";
		n+="</table>";
	n+="</div>";
	n+="<div id='e-"+id+"-reloadanim' class='reloadAnim'></div>";
	obj.innerHTML=n;

	obj.dataset.cursor="";
	
	if (obj.dataset.var1>0 && obj.dataset.var4==0) { 
		//Kamera vorhanden und Defaultansicht=Livebild
		control20_Refresh(id); 
	}

	if (obj.dataset.var3>0) { 
		//Archiv vorhanden, d.h. Archiv kann per Click geöffnet werden / Navigation
		document.getElementById("e-"+id+"-imglive").addEventListener(downEvent,function(){if (!checkClick()){return;} control20_ArchivOpen(id);},false);
		document.getElementById("e-"+id+"-last").addEventListener(downEvent,function(){if (!checkClick()){return;} showShortClickItem(this); control20_ArchivNavigate(id,-1);},false);
		document.getElementById("e-"+id+"-info").addEventListener(downEvent,function(){if (!checkClick()){return;} showShortClickItem(this); control20_ArchivNavigate(id,0);},false);
		document.getElementById("e-"+id+"-next").addEventListener(downEvent,function(){if (!checkClick()){return;} showShortClickItem(this); control20_ArchivNavigate(id,1);},false);
		if (obj.dataset.var1>0) { 
			//Kamera vorhanden, d.h. Archiv kann per Click geschlossen werden (LiveBild)
			document.getElementById("e-"+id+"-imgarchiv").addEventListener(downEvent,function(){if (!checkClick()){return;} control20_ArchivClose(id);},false); 
		}
		if (obj.dataset.var4==1 || obj.dataset.var1==0) { 
			//Defaultansicht=Archivbild (oder keine Kamera vorhanden)
			control20_ArchivOpen(id); 
		}
	}

	if (obj.dataset.var0==1) {obj.addEventListener(downEvent,function(){if (!checkClick()){return;} visuElementClick(id);},false);}
}

function control20_Refresh(elementId) {
	var d=document.getElementById("e-"+elementId);
	if (d) {
		if (screensaverActive) {

			//nur den Timer setzen, kein Refresh des Bildes
			control20_SetTimer(elementId,false);

		} else {

			//Refresh des Kamerabildes (Timer wird per Ajax gesetzt)
			if (d.dataset.refreshtimer) {clearTimeout(d.dataset.refreshtimer);}
			document.getElementById("e-"+elementId+"-reloadanim").style.display="inline";

			var n=elementId+AJAX_SEPARATOR1+d.dataset.var1+AJAX_SEPARATOR1+d.dataset.var2+AJAX_SEPARATOR1;
			ajax("camLive",1020,visu_visuid,0,n,"");

		}
	}
}

function control20_SetTimer(elementId,statusOk) {
	var d=document.getElementById("e-"+elementId);
	if (d) {
		var img=document.getElementById("e-"+elementId+"-imglive");
		if (statusOk) {
			img.style.webkitFilter="contrast(1)";
			img.style.opacity="1";
		} else {
			img.style.webkitFilter="contrast(0.3)";
			img.style.opacity="0.75";
		}
		document.getElementById("e-"+elementId+"-reloadanim").style.display="none";
		if (d.dataset.refreshtimer) {clearTimeout(d.dataset.refreshtimer);}
		
		if (img.dataset.stream==1) {
			//Streaming
			if (img.style.display!="none") {
				if (screensaverActive) {
					clearObject("e-"+elementId+"-imglive",0); //bei Stream den iFrame entfernen, damit der Stream stoppt
					d.dataset.refreshtimer=window.setTimeout("control20_Refresh('"+elementId+"');",3*1000); //alle 3s prüfen, ob Screensaver wieder inaktiv ist
				} else {
					d.dataset.refreshtimer=window.setTimeout("control20_SetTimer('"+elementId+"',true);",3*1000); //alle 3s prüfen, ob Screensaver aktiv ist (Stream hat ja keinen echten Refresh)
				}
			}
			
		} else {
			//Einzelbilder
			if (d.dataset.var2>0 && img.style.display!="none") {
				if (screensaverActive) {
					d.dataset.refreshtimer=window.setTimeout("control20_Refresh('"+elementId+"');",3*1000); //alle 3s prüfen, ob Screensaver wieder inaktiv ist
				} else {
					d.dataset.refreshtimer=window.setTimeout("control20_Refresh('"+elementId+"');",d.dataset.var2*1000);
				}
			}
		}
	}
}

function control20_ArchivNavigate(elementId,mode) {
	//mode: -1=jüngeres Bild, 1=älteres Bild, 0=aktuellster Archiveintrag oder aktueller Cursor (also das zuletzt angezeigte Archivbild)
	var d=document.getElementById("e-"+elementId);
	if (d) {
		var n=elementId+AJAX_SEPARATOR1+mode+AJAX_SEPARATOR1+d.dataset.cursor+AJAX_SEPARATOR1+d.dataset.var1+AJAX_SEPARATOR1+d.dataset.var3+AJAX_SEPARATOR1;
		ajax("camArchiv",1020,visu_visuid,0,n,"");
	}
}

function control20_ArchivOpen(elementId) {
	//Archiv öffnen und aktuellsten Eintrag anzeigen
	document.getElementById("e-"+elementId+"-reloadanim").style.display="none";
	document.getElementById("e-"+elementId+"-imglive").style.display="none";
	if (document.getElementById("e-"+elementId+"-imglive").dataset.stream==1) {
		clearObject("e-"+elementId+"-imglive",0); //bei Stream den iFrame entfernen, damit der Stream stoppt
	}
	document.getElementById("e-"+elementId+"-imgarchiv").style.display="inline";
	document.getElementById("e-"+elementId+"-archiv").style.display="inline";
	//transparentes Pixel:
	document.getElementById("e-"+elementId+"-imgarchiv").src="data:image/png;base64,iVBORw0KGgoAAAANSUhEUgAAAAEAAAABCAYAAAAfFcSJAAAADUlEQVQIHWP4//8/AwAI/AL+5gz/qwAAAABJRU5ErkJggg==";
	//jetzt aktuellsten (bzw. zuletzt ausgewählten) Eintrag per Ajax schnappen
	control20_ArchivNavigate(elementId,0);
}

function control20_ArchivClose(elementId) {
	//Archiv schliessen und LiveBild anzeigen
	document.getElementById("e-"+elementId+"-imglive").style.display="inline";
	document.getElementById("e-"+elementId+"-imgarchiv").style.display="none";
	document.getElementById("e-"+elementId+"-archiv").style.display="none";
	//Livebild abdunkeln (ist ja veraltet)
	document.getElementById("e-"+elementId+"-imglive").style.webkitFilter="contrast(0.3)";
	document.getElementById("e-"+elementId+"-imglive").style.opacity="0.75";
	//transparentes Pixel:
	document.getElementById("e-"+elementId+"-imgarchiv").src="data:image/png;base64,iVBORw0KGgoAAAANSUhEUgAAAAEAAAABCAYAAAAfFcSJAAAADUlEQVQIHWP4//8/AwAI/AL+5gz/qwAAAABJRU5ErkJggg==";
	control20_Refresh(elementId);
}
