/* 
 * EDOMI beta (Version 1.50) - Intelligente Steuerung und Visualisierung KNX-basierter Elektro-Installationen.
 * @link http://www.edomi.de 
 * @author Dr. Christian Gärtner <dr.christian.gaertner@googlemail.com> 
 * @copyright 2015,2016,2017 Dr. Christian Gärtner 
 * @license Freeware 
 *
 *     This file and all other files are part of EDOMI.
 *
 *     EDOMI is distributed in the hope that it will be useful,
 *     but WITHOUT ANY WARRANTY; without even the implied warranty of
 *     MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 *
 *     Diese und alle anderen Dateien sind Teil von EDOMI.
 *
 *     EDOMI wird in der Hoffnung, dass es nützlich sein wird, aber
 *     OHNE JEDE GEWÄHRLEISTUNG, bereitgestellt; sogar ohne die implizite
 *     Gewährleistung der MARKTFÄHIGKEIT oder EIGNUNG FÜR EINEN BESTIMMTEN ZWECK.
*/ 
//Controltyp 29 (Bild-/Webseiten-URL)
//----------------------------

function control29_construct(obj,id) {
	if (obj.dataset.var2==0) { 
		//Bild-URL
		if (obj.dataset.var4==0) {var tmp='width:100%; height:100%;';}
		else if (obj.dataset.var4==1) {var tmp='width:100%; height:auto;';}
		else if (obj.dataset.var4==2) {var tmp='width:auto; height:100%;';}
		else if (obj.dataset.var4==3) {var tmp='width:auto; height:auto;';}
		//per Default wird ein transparentes Pixel angezeigt - die echte URL wird per JS gesetzt
		var n="<img id='e-"+id+"-urlcontent' src='data:image/png;base64,iVBORw0KGgoAAAANSUhEUgAAAAEAAAABCAYAAAAfFcSJAAAADUlEQVQIHWP4//8/AwAI/AL+5gz/qwAAAABJRU5ErkJggg==' style='"+tmp+" margin:0; padding:0; border:none; overflow:hidden; pointer-events:none;'>";
		n+="<div id='e-"+id+"-reloadanim' class='reloadAnim'></div>";
	} else {
		//Webseiten-URL (iFrame)
		//per Default wird "about:blank" angezeigt - die echte URL wird per JS gesetzt
		if (obj.dataset.var1==1) {
			var n="<iframe id='e-"+id+"-urlcontent' src='about:blank' style='position:absolute; left:0; top:0; width:100%; height:100%; margin:0; padding:0; border:none; overflow:hidden; background:transparent;'></iframe>";
		} else {
			var n="<iframe id='e-"+id+"-urlcontent' src='about:blank' style='position:absolute; left:0; top:0; width:100%; height:100%; margin:0; padding:0; border:none; overflow:hidden; background:url(data:image/png;base64,iVBORw0KGgoAAAANSUhEUgAAAAUAAAAFCAYAAACNbyblAAAAAXNSR0IArs4c6QAAAChJREFUCB1jZGBgMAZiZODDhMwDsn2AeAuyIFgApAgmCBeACaIIgAQBzpEEiaAV3YQAAAAASUVORK5CYII=);'></iframe>";
		}
		n+="<div id='e-"+id+"-reloadanim' class='reloadAnim'></div>";
	}
	obj.innerHTML=n;

	if (obj.dataset.var0==1) {obj.addEventListener(downEvent,function(){if (!checkClick()){return;} visuElementClick(id);},false);}
}

function control29_Refresh(elementId,url) {
	var d=document.getElementById("e-"+elementId);
	if (d) {
		if (screensaverActive) {

			//nur den Timer setzen, kein Refresh
			control29_setTimer(elementId,false,url);

		} else {

			//Refresh
			if (d.dataset.refreshtimer) {clearTimeout(d.dataset.refreshtimer);}
			document.getElementById("e-"+elementId+"-reloadanim").style.display="inline";
			
			var tmp=new Date(); 
			var ts="TS"+tmp.getDate()+(tmp.getMonth()+1)+tmp.getFullYear()+tmp.getHours()+tmp.getMinutes()+tmp.getSeconds();

//###Optimal wäre: Wenn url ungültig(!) ist -> about:blank
			if (url=="") {url="about:blank";}

			document.getElementById("e-"+elementId+"-urlcontent").src=url+"?&"+ts;

			document.getElementById("e-"+elementId+"-urlcontent").onload=function() {control29_setTimer(elementId,true,url);}
			document.getElementById("e-"+elementId+"-urlcontent").onerror=function() {control29_setTimer(elementId,false,url);}

		}
	}
}

function control29_setTimer(elementId,statusOk,url) {
	var d=document.getElementById("e-"+elementId);
	if (d) {
		if (statusOk) {
			document.getElementById("e-"+elementId+"-urlcontent").style.webkitFilter="contrast(1)";
			document.getElementById("e-"+elementId+"-urlcontent").style.opacity="1";
		} else {
			document.getElementById("e-"+elementId+"-urlcontent").style.webkitFilter="contrast(0.3)";
			document.getElementById("e-"+elementId+"-urlcontent").style.opacity="0.75";
		}
		
		document.getElementById("e-"+elementId+"-reloadanim").style.display="none";
		if (d.dataset.refreshtimer) {clearTimeout(d.dataset.refreshtimer);}

		if (d.dataset.var3>0) {
			if (screensaverActive) {
				d.dataset.refreshtimer=window.setTimeout("control29_Refresh('"+elementId+"','"+stringEscapeSingleQuote(url)+"');",3*1000);
			} else {
				d.dataset.refreshtimer=window.setTimeout("control29_Refresh('"+elementId+"','"+stringEscapeSingleQuote(url)+"');",d.dataset.var3*1000);
			}
		}
	}
}
